// Header File
// Created 11/14/2004; 12:51:40 AM


/************************************************************************************
 *	these ROM_CALL where discovered/analyzed/understood/made public by Kevin Kofler.
 *	For more informations:
 *	http://pws.tigen.org/forum/index.php?action=sujet&forum=5&cat=20&topic=1402&page=1#14
 *************************************************************************************/



#define XR_stringPtr_addr (_rom_call_addr(293))
#define IsSupportedAMS300() (*(long long*)(XR_stringPtr_addr-116)\
==0x76021003261f4e75ll)
#define DetectLinkInterface ((unsigned char(*)(void))(XR_stringPtr_addr-158))
#define DetectReceiveInterface ((unsigned char(*)(short))(XR_stringPtr_addr\
-108))
#define DetectUSB (*(short(**)(void))(DetectLinkInterface+4))
#define USB_SendData ((short (*)(const void *, size_t, long))(DetectUSB-1518))
#define USB_RecvData ((short (*)(void *, size_t, long))(DetectUSB-1270))
#define USBLinkClose ((short(*)(void))(DetectUSB-1290))
#define USBLinkReset (*(void(**)(void))(DetectLinkInterface+36))

/*
unsigned char DetectLinkInterface(void); (0x8d2572)


Detects if the USB link is usable. Returns 1 (USB preferred) if it is and 2
(legacy DBus IO preferred) if it isn't. This routine uses DetectUSB first,
and then runs a complex test transfer to double-check. This test transfer
needs to be handled on the receiving side as well, so it is usually easier
to just use DetectUSB.
*/

/*
short DetectUSB(void); (0x94a174)


Quickly detects if the USB link is usable. Returns 0 if USB is available,
or a non-zero error code if it isn't.
*/


/*
unsigned char DetectReceiveInterface(short allowLIO); (0x8d25a4)



Waits for a calculator to connect on either the USB or the LIO interface.
Returns:
* 0 if something is detected on the USB link.
* 2 if allowLIO is non-zero, nothing is detected on the USB link and
  something is detected on the LIO link.
* 3 if interrupted by the user ([ON] key).
If you want to wait for something to be received on the USB link,
DetectReceiveInterface(FALSE) is the function to use, but there's a catch:
only one calculator can use DetectReceiveInterface for each transfer. (USB is
a host/client protocol.) You absolutely MUST call USBReset on both calculators
before using DetectReceiveInterface on the other calculator. This is very much
unlike the LIO interface, which is peer-to-peer. Also, the other calculator
MUST call DetectUSB to synchronize with a DetectReceiveInterface call. To sum
up, for a transfer which is synchronized by the sender (such as a move in a
turn-based game), 

the sending calculator should call: 
USBLinkClose(); USBLinkReset(); DetectUSB(); USB_SendData(src,size,2000);, the receiving
calculator should call: 
USBLinkClose(); USBLinkReset(); DetectReceiveInterface(FALSE); USB_RecvData(src,size,2000);.*/
/*
short USB_SendData(const void *buffer, size_t size, long timeout); (0x949b86)

Sends size bytes from buffer over the USB link. For "timeout", try 2000. (I
am not sure this is actually a timeout. AMS always uses 2000, so you should
do the same.) Returns 0 if successful, some non-0 error code otherwise.*/
/*
short USB_RecvData(void *buffer, size_t size, long timeout); (0x949c7e)

Receives size bytes into buffer from the USB link. For "timeout", try 2000. (I
am not sure this is actually a timeout. AMS always uses 2000, so you should
do the same.) Returns 0 if successful, some non-0 error code otherwise.
*/

/*
short USBLinkClose(void); (0x949c6a)

This function is used by AMS to finalize a file transfer.
Returns 0 if successful, some non-0 error code otherwise.
*/
/*
void USBLinkReset(void); (0x94a284)

This function closes and resets the USB link. It is used by AMS when done with
an USB transfer, and sometimes also before initiating one. You should always
call this function when done with a transfer.*/