// C Source File
// Created 12/7/2004; 7:13:12 PM


#include <tigcclib.h>
#include "extgraph.h"
#include "define.h"
#include "structures.h"

	
	
extern unsigned short S_tile[];
extern unsigned short S_animated_tile[];


char * buffer1;
char* buffer2;
char * buffer3;
char* buffer4;
LEVEL lvl;
INT_HANDLER save_int_1;
INT_HANDLER save_int_5;

static unsigned short xxx[] = {
	0b1110000000000111,
	0b1111000000001111,
	0b1111100000011111,
	0b0111110000111110,
	0b0011111001111100,
	0b0001111111111000,
	0b0000111111110000,
	0b0000011111100000,
	0b0000011111100000,
	0b0000111111110000,		
	0b0001111111111000,		
	0b0011111001111100,		
	0b0111110000111110,		
	0b1111100000011111,		
	0b1111000000001111,		
	0b1110000000000111,
};
static unsigned short xx[]={
	0b1111100000011111,
	0b1110000000000111,
	0b1100000000000011,
	0b1000000000000001,
	0b1000000000000001,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,	
	0b1000000000000001,
	0b1000000000000001,		
	0b1100000000000011,		
	0b1110000000000111,
	0b1111100000011111				
};

// C Source File
// Created 10/21/2004; 6:17:33 PM

unsigned char *Get_Data_Ptr(const char *Filename, short Offset) {
	unsigned char *Location;
	SYM_ENTRY *SymPtr;

	if ((SymPtr = SymFindPtr(SYMSTR(Filename), 0)) == NULL)
		return NULL;  // File not found

	if ((Location = (unsigned char*) HeapDeref(SymPtr->handle)) == NULL)
		return NULL;
	return (Location + 2 + Offset);
}



void Archive(const char *Filename) {
	SYM_ENTRY *SymPtr = NULL;
	HSym hsym = SymFind(SYMSTR(Filename));
	SymPtr = DerefSym (hsym);
	if (EM_findEmptySlot(*Get_Data_Ptr(Filename, -2)) == NULL)
		return;  // Make sure Garbage Collection will not occur
	if (!SymPtr->flags.bits.archived)
		EM_moveSymToExtMem(SYMSTR(Filename), HS_NULL);
}



void UnArchive(const char *Filename) {
	SYM_ENTRY *SymPtr = NULL;
	HSym hsym = SymFind(SYMSTR(Filename));
	SymPtr = DerefSym (hsym);	
	if (SymPtr->flags.bits.archived)
		EM_moveSymFromExtMem(SYMSTR(Filename), HS_NULL);
}


short Save_File(const char *FileName) {
	//Actually save the thing
	const unsigned char Tag[6] = { 0, 'B', 'D', 'u', 0, OTH_TAG };
	char *Base;
	int Size;
	HANDLE h;
	SAVE_STRUCT Save;

	Save.size = sizeof(Save)-2;
	Save.Magic = 7897;
	memcpy(&Save.lvvl,&lvl, sizeof(LEVEL));
	memcpy(&Save.Tag, Tag, 6);

	Size = Save.size+2;

	UnArchive(FileName);  // Make sure that before writing to the file, it is not archived

	if ((h = HeapAlloc(Size)) == H_NULL)
		return FALSE;
	if ((Base = HeapDeref(DerefSym(SymAdd(SYMSTR(FileName)))->handle = h)) == NULL) {
		HeapFree(h);
		return FALSE;
	}
	memcpy(Base, &(Save), Size);
	//Archive(FileName);    // Automatically Archive the file in case of a crash
	return TRUE;
}


void draw_level(LEVEL lvl,char* b1, char * b2, short draw_in_one_plane) {
	int i,j;
	for (i=0;i<LEVEL_HEIGHT;i++) {
		for (j=0;j<LEVEL_WIDTH;j++) {
			GrayTile16x16_RPLC_R(j,i<<4,&S_tile[lvl.map[i][j]<<5],&S_tile[(lvl.map[i][j]<<5)+16],b1,b2);
		}
	}
	
	for (i=0;i<4;i++) {
		Tile16x16_OR_R((lvl.spawn_x[i])>>4,lvl.spawn_y[i]+5,xxx,b2);
		if (draw_in_one_plane==FALSE)
		GrayTile16x16_OR_R((lvl.spawn_x[i])>>4,lvl.spawn_y[i]+5,xxx,xxx,b2,b1);
	}
}

void copy (short n) {
	memcpy(buffer3,buffer1+1+n,80*30);
	memcpy(buffer4,buffer2+1+n,80*30);
}

void init(int mode) {
	GrayClearScreen2B(buffer3,buffer4);
	memset(buffer3+80*30,0b11111111,60);
	memset(buffer4+80*30,0b10101010,60);
	static const char *str[]={(char*)&"Keys: [+], [-], [ENTER]",(char*)&"Keys: Arrows and [ENTER]"};
	GrayDrawStr2B(0,85,"[F1] to return to the menu",A_NORMAL,buffer3,buffer4);	
	GrayDrawStr2B(0,93,str[mode],A_NORMAL,buffer3,buffer4);
}






void edit_spawn() {
	int x=2,y=2,time=0,n=0;
	init(1);
	while (n<4) {
		copy(((y*30)<<4)-16*3*30);
		
		time++;
		
		if (time<15)	
			GrayClipSprite16_OR_R(-8+(x<<4),16*3,16,xx,xx,buffer3,buffer4);			
		if (time==20)
			time = 0;
			
			
		
		if (_keytest(RR_F1))
			return;
		if (_keytest(RR_UP) && y > 0) {
			y--;
			while (_keytest(RR_UP)) {};
		}
		if (_keytest(RR_DOWN) && y != LEVEL_HEIGHT-1) {
			y++;
			while (_keytest(RR_DOWN)) {};
		}
		if (_keytest(RR_LEFT) && x > 0) {
			x--;
			while (_keytest(RR_LEFT)) {};
		}
		if (_keytest(RR_ENTER) || _keytest(RR_2ND)) {
			lvl.spawn_x[n] = x<<4;
			lvl.spawn_y[n] = (y<<4)-5;
			n++;	
			GrayTile16x16_OR_R(x,y<<4,xxx,xxx,buffer1,buffer2);
			while(_keytest(RR_ENTER)) {};
		}
		if (_keytest(RR_RIGHT) && x != LEVEL_WIDTH-1) {
			x++;
			while (_keytest(RR_RIGHT)) {};
		}

		memcpy(GrayGetPlane(0),buffer3,LCD_SIZE);
		memcpy(GrayGetPlane(1),buffer4,LCD_SIZE);	
	}
	
}


void edit_tiles() {
	int x=2,y=2,type=cratere_lunaire,time=0,i=0;
	init(0);
	while (!_keytest(RR_F1)) {
		copy(((y*30)<<4)-16*3*30);
		
		time++;
		
		if (time<15)
			GrayClipSprite16_RPLC_R(-8+(x<<4),16*3,16,&S_tile[type<<5],&S_tile[(type<<5)+16],buffer3,buffer4);		
			GrayClipSprite16_OR_R(-8+(x<<4),16*3,16,xx,xx,buffer3,buffer4);				
		if (time==30)
			time = 0;
		if (_keytest(RR_F1))
			return;
		
		if (_keytest(RR_UP) && y > 0) {
			y--;
			while (_keytest(RR_UP)) {};
		}
		if (_keytest(RR_DOWN) && y != LEVEL_HEIGHT-1) {
			y++;
			while (_keytest(RR_DOWN)) {};
		}
		if (_keytest(RR_LEFT) && x > 0) {
			x--;
			while (_keytest(RR_LEFT)) {};
		}
		if (_keytest(RR_ENTER) || _keytest(RR_2ND)) {
			lvl.map[y][x] = type;
			draw_level(lvl,buffer1,buffer2,0);
		}
		if (_keytest(RR_RIGHT) && x != LEVEL_WIDTH-1) {
			x++;
			while (_keytest(RR_RIGHT)) {};
		}
		//GrayClipSprite16_RPLC_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned short *sprt0,unsigned short *sprt1,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));
		
		for (i=3;i--;)
		GraySprite16_RPLC_R(104+i*18,83,16,&S_tile[(type+i-1)<<5],&S_tile[((type+i-1)<<5)+16],buffer3,buffer4);
		
		GrayClipSprite16_OR_R(104+18,83,16,xx,xx,buffer3,buffer4);		
		if (_keytest(RR_PLUS)) {
			type++;
			//if (type==ground4+1)
			//type = bomb_small;
			
			while (_keytest(RR_PLUS)) {};
		}
		if (_keytest(RR_MINUS)) {
			type--;
			while (_keytest(RR_MINUS)) {};
		}
		memcpy(GrayGetPlane(0),buffer3,LCD_SIZE);
		memcpy(GrayGetPlane(1),buffer4,LCD_SIZE);	
	}
}


void draw_preview() {
	short x=0,y=0,type=0;
	for (y=3;y--;) {
		for (x=3;x--;) {
			type = lvl.preview[y*3+x];
			GraySprite16_RPLC_R(100+(x<<4),20+(y<<4),16,&S_tile[(type)<<5],&S_tile[((type)<<5)+16],GrayGetPlane(0),GrayGetPlane(1));
		}
	}
}



void edit_preview() {
	GrayClearScreen();
	GrayDrawStr(0,0,"...:::Editing the preview:::...",A_NORMAL);
	GrayDrawStr(0,8,"Just choose the sprites you",A_NORMAL);		
	GrayDrawStr(0,16,"want with [+] and [-]",A_NORMAL);		
	GrayDrawStr(0,28,"Press enter to put the sprite",A_NORMAL);
	GrayDrawStr(0,38,"Press F1 to go to the menu",A_NORMAL);			

	int x=0,y=0,type=cratere_lunaire,time=0,i=0;
	init(0);
	while (!_keytest(RR_F1)) {			
	draw_preview();
	time++;
		if (time<15)
			GrayClipSprite16_RPLC_R(100+(x<<4),20+(y<<4),16,&S_tile[type<<5],&S_tile[(type<<5)+16],GrayGetPlane(0),GrayGetPlane(1));
			GrayClipSprite16_OR_R(100+(x<<4),20+(y<<4),16,xx,xx,GrayGetPlane(0),GrayGetPlane(1));				
		if (time==30)
			time = 0;
		if (_keytest(RR_F1))
			return;
		if (_keytest(RR_UP) && y > 0) {
			y--;
			while (_keytest(RR_UP)) {};
		}
		if (_keytest(RR_DOWN) && y < 2) {
			y++;
			while (_keytest(RR_DOWN)) {};
		}
		if (_keytest(RR_LEFT) && x > 0) {
			x--;
			while (_keytest(RR_LEFT)) {};
		}
		if (_keytest(RR_ENTER) || _keytest(RR_2ND)) {
			lvl.preview[y*3+x]=type;
		}
		if (_keytest(RR_RIGHT) && x < 2) {
			x++;
			while (_keytest(RR_RIGHT)) {};
		}

		//Choose the tile
		for (i=7;i--;)
		GraySprite16_RPLC_R(10+i*18,80,16,&S_tile[(type+i-3)<<5],&S_tile[((type+i-3)<<5)+16],GrayGetPlane(0),GrayGetPlane(1));	
		GrayClipSprite16_OR_R(10+18*3,80,16,xx,xx,GrayGetPlane(0),GrayGetPlane(1));		
		if (_keytest(RR_PLUS)) {
			type++;	
			while (_keytest(RR_PLUS)) {};
		}
		if (_keytest(RR_MINUS)) {
			type--;
			while (_keytest(RR_MINUS)) {};
		}
	}
};


short menu() {
	clrscr();
	short result = NOTHING;
	HANDLE handle = PopupNew ("BD v0.96 Map Editor", 0);	
	PopupAddText (handle,	-1, "Save map", 										SAVE);
	PopupAddText (handle, -1, "Load map", 										LOAD);
	PopupAddText (handle, -1, "Edit the background", 					BACKGROUND);
	PopupAddText (handle, -1, "Edit destruction animation",		BLOCK);
	PopupAddText (handle, -1, "Edit spawning points", 	SPAWN);
	PopupAddText (handle, -1,	"Edit Preview", 								PREVIEW);
	PopupAddText (handle, -1, "See Documentation", 						HELP);		
	PopupAddText (handle, -1, "Quit", 												EXIT);
	
	result = PopupDo (handle, 10,10, SAVE);
	
	HeapFree (handle);


	result = result*(result!=EXIT);

	return(result);	
}



void q() {
	while (!_keytest(RR_ENTER)) {};
	while (_keytest(RR_ENTER)) {};
	clrscr();
}

void help() {
	GrayOff();
	clrscr();		
printf("
Bomber Dude Map Editor's Help !

When you launch the program, a 'default map' is automaticly loaded.
But you can load and thus edit any map previously made.

Press [ENTER]");
		q();
printf("
With this program, you can:
>Edit the background of the map
>Edit the spawning points of the map
>Select the destructible block (and the animation)
>Edit the preview
>Save the map

Press [Enter] to continue :D
");
		q();
printf("
...:::Editing the background:::...

You can put the blocks you want in the places you want. The block currently
selected is displayed on the right. To change the selected block,
press [+] or [-]. To move the block use the arrows. To put the block in the map
press [ENTER] or [2ND].
To return to the menu press [F1].

Press [Enter] to continue...");
		q();
printf("
...:::Editing the spawning points:::...

Just select the 4 spawning positions

Press [Enter]");
		q();
printf("
...:::Saving the map:::...

Well with this you can save the map to later
play it in Bomber Dude... Save often, because
there is no 'undo' key ! Saving will replace
any variable with the same name, even if it's
archived.

Press [Enter]");
		q();
printf("
...:::Choosing the destructible blocks:::...

When you edit the tiles, you don't put the
block that you can destroy when you play
because the program randomly put them.
What you do is:
1/choose what appearance they will have
2/choose what animation will happen
when they explode.

Press [Enter] to return to the menu");
	q();
	GrayOn();
}


short keyx(short type) {
	
	if (_keytest(RR_MINUS) || _keytest(RR_LEFT)) {
			type--;
			while (_keytest(RR_MINUS) || _keytest(RR_LEFT)) {};
	}
	if (_keytest(RR_PLUS) ||  _keytest(RR_RIGHT)) {
			type++;
			while (_keytest(RR_PLUS) || _keytest(RR_RIGHT)) {};
	}		
	return(type);
}




void edit_soft_block() {
	ClearGrayScreen();
	
	GrayDrawStr(0,10,"...:::Edit Destructable Block:::...",A_NORMAL);
	int type = lvl.soft_block;
	GrayDrawStr(0,18,"Choose the destructible block that will",A_NORMAL);
	GrayDrawStr(0,24,"randomly be inserted in the map",A_NORMAL);
	GrayDrawStr(0,30,"Press [Left] or [Right] and [Enter]",A_NORMAL);
	
	while (!(_keytest(RR_ENTER) || _keytest(RR_2ND))) {
		GraySprite16_RPLC_R(140,2,16,&S_tile[type<<5],&S_tile[(type<<5)+16],GrayGetPlane(0),GrayGetPlane(1));
		
			type=keyx(type);
			if (type>space_empty+bonus6b+2)
			type = cratere_lunaire;
			if (type < igloo_LU-2)
			type = space_empty+bonus6b+1;

		lvl.soft_block = type;
	}
	
	while (_keytest(RR_ENTER) || _keytest(RR_2ND)) {};
	
	type = lvl.exploding_block;
	GrayDrawStr(0,48,"Now choose the animation that occurs",A_NORMAL);
	GrayDrawStr(0,54,"when the block explodes",A_NORMAL);
	GrayDrawStr(0,60,"Press [Left] or [Right] and [Enter]",A_NORMAL);
	int i;
	while (!(_keytest(RR_ENTER) || _keytest(RR_2ND))) {
		
		for (i=4;i--;)
			GraySprite16_RPLC_R(10+i*20,80,16,&S_animated_tile[(type+i)<<5],&S_animated_tile[((type+i)<<5)+16],GrayGetPlane(0),GrayGetPlane(1));
		
			type=keyx(type);
			
			if (type> bonus6b+5)
			type = -space_empty-5;
			if (type < -space_empty-5)
			type = bonus6b+5;				

		lvl.exploding_block = type;
	}	
}


void input_str(char *str,int x,int y,int maxlen, int min, int max)//modified routine from cave blaster (one of Tigcc's example)
{
	
	SetIntVec (AUTO_INT_1, save_int_1);
	SetIntVec (AUTO_INT_5 , save_int_5);	
	
	int i=0,key=0;
	while(key!=13)
	{
		str[i]='_'; str[i+1]=' '; str[i+2]=0;
		DrawStr(x,y,"                                    ",A_REPLACE);
		DrawStr(x,y,str,A_REPLACE);
		key=ngetchx();
		if(key>=min&&key<=max&&i<maxlen) str[i++]=key;
		if(key==257&&i) i--;
	}
	str[i]=0;
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
	SetIntVec (AUTO_INT_5, DUMMY_HANDLER);
	while (_keytest(RR_ENTER)) {};
}



void get_name(char * str) {
	GrayOff();
	clrscr();
	printf("
Input the map's name !

If the name is longer than 8 characters it will be shortened
Also, be aware that it will replace any variable with the same name.
Too cancel, input an invalid name.
");
		
		while(_keytest(RR_3)) {};
		input_str(str,60,80,8,'A','z');
		
		
		if (strlen(str)<2) {
						clrscr();
						printf("File name too short\nfile not saved!\n\nPress [Enter]");
						while (_keytest(RR_ENTER)) {};
						while (!_keytest(RR_ENTER)) {};
						str[0]=0;
		}
		GrayOn();
}







static inline short Find_All_Files(char (*File_Names)[9], const unsigned short Magic_NO) {
	short Counter = 0;
	SYM_ENTRY *SymPtr = SymFindFirst (NULL, FO_RECURSE);
	
	while(SymPtr != NULL) {
		if (*(unsigned short*)(HeapDeref(SymPtr->handle) + 2) == Magic_NO)
			strcpy(File_Names[Counter++], SymPtr->name);
		SymPtr = SymFindNext();
	}
	
	File_Names[Counter][0] = 0;
	return Counter;
}



void load_map() {
	GrayOff();
	char tracks[99][9];
	char n=Find_All_Files(tracks, MAGIC_NUM_CUSTOM);
	
	clrscr();
	if (n<1) {
		printf("No map found :(\npress [Enter] to go back");
		while (!_keytest(RR_ENTER)) {};
		return;
	}
	int i=0;
	printf("Choose map:\nif you don't want to load a map, input an invalid number\n");
	while (tracks[i][0] != 0 && i<10) {
		printf("\n%i/ ",i);
		printf(tracks[i]);
		i++;
	}
	while (_keytest(RR_2)) {};
	char str[4];
	input_str(str,30,90,2,'0','9');
	char **f=NULL;	
	int load_num = strtol (str,f, 10);
	if (load_num>=n || n<1) {
		printf("\n\nCant load this map\nput a number in the interval [0;%i]",n-1);
	}
	else
	{
		SAVE_STRUCT s;

		memcpy(&s,Get_Data_Ptr(tracks[load_num],-2),sizeof(SAVE_STRUCT));
		memcpy(&lvl,&(s.lvvl),sizeof(LEVEL));
		printf("\n\nMap %i loaded!",load_num);
	}
	printf("\nPress Enter");
	//DrawStr(10,80,tracks[load_num],A_REPLACE);
	
	while (!_keytest(RR_ENTER)) {};
	while (_keytest(RR_ENTER)) {};
	
	GrayOn();
	
}






void _main(void) {

	buffer1 = malloc(BUFFER_SIZE*4);
	buffer2 = buffer1+BUFFER_SIZE;
	buffer3 = buffer2+BUFFER_SIZE;	
	buffer4 = buffer3+BUFFER_SIZE;	
	LEVEL lvl2=
	{
		{
			{border_UL,border_U,border_U,border_U,border_U,border_U,border_U,border_U,border_U,border_U,border_UR},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_L,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,carelage,border_R},
			{border_DL,border_D,border_D,border_D,border_D,border_D,border_D,border_D,border_D,border_D,border_DR}
		},
		{custom1,custom2,custom3,custom1,custom2,custom3,custom1,custom2,custom3},
			quasi_pyramide,
			quatre_cubes,
			exploding_cube1,
		{
				0,0,0,0,
				0,0,0,0,
				0,0,0,0,
				0,0,0,0		
		},
		{
				16,144,16,144
			},
			{
					11,203,203,11
				},	
	};
	
	
	lvl= lvl2;


	
	
	FontSetSys(F_4x6);		
	
	

	
	

	
	
	short k=k;
	char str[9];
	while ((k = menu()) && k!=FALSE) {
		
		save_int_1 = GetIntVec (AUTO_INT_1);
		save_int_5 = GetIntVec (AUTO_INT_5);
		SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
		SetIntVec (AUTO_INT_5, DUMMY_HANDLER);
		GrayOn();
		draw_level(lvl,buffer1,buffer2,k==SPAWN);
		
		if (k==BACKGROUND) {
			edit_tiles();
		}
		if (k==HELP)
			help();
		
		if (k==SPAWN)
			edit_spawn();
		if (k==PREVIEW)
			edit_preview();
		
		if (k==LOAD)
			load_map();
		
		if (k==BLOCK)
			edit_soft_block();
		if (k==SAVE) {
			get_name(str);
			if (str[0]!=0)
			Save_File(str);
		}

		while (_keytest(RR_ENTER)) {};
		
		GrayOff();
		SetIntVec (AUTO_INT_1, save_int_1);
		SetIntVec (AUTO_INT_5 , save_int_5);

	}
	
	free(buffer1);
	GrayOff();
	while (_keytest(RR_7)) {};

	
}