// C Source File
// Created 8/7/2004; 4:11:37 PM
#include <tigcclib.h>
#include "extgraph.h"
#include "define.h"
#include "structures.h"
#include "sprites-bomber.h"
#include "globals.h"
#include "hard.h"
#include "igloo.h"



//main.c
void delete_animated_tile (short, short);
void animate_explosion(short, short, short, short, short *);
//load_external.c

char *Get_Data_Ptr(const char *, short);
//load_external.c
void copy_level(void*);

//Globals used here
char* generated_sprites[4];
short playernum;
short transporterr[16];
PLAYA player[6];
void* virtual[5];
short (*maps)[LEVEL_WIDTH][LEVEL_HEIGHT];
short screen_offset_y;
BOMB* bombs;
short hard_block;
short soft_block;
short exploding_block;
short level;
short link_on;
short level_num;
short	spawnx[4];
short	spawny[4];
short custom_lvl_number;




/*********************************************************************************************************
 *	Draws a vertical string
 *********************************************************************************************************/

void vertical_string(char *str, short x, short y) {
	FontSetSys(F_8x10);
	short i=0;
	while (str[i]!='\0') {
		GrayDrawChar(x,y+(i*11),str[i],A_XOR);
		i++;
	}
}

/*********************************************************************************************************
 *	Generates all the tiles (the 4 all players have a different color)
 *********************************************************************************************************/
void generate_the_sprites() {
	short i,j;
	char* address;
	for (i=0;i<4;i++) {
		memcpy(generated_sprites[i]+(88*3),S_perso/*-88*3*/,88*3*3);
		memcpy(generated_sprites[i]+2*22*2*4*4,death_sprites_dark,432);		
		for (j=3;j<3*4;j++) {
			address=generated_sprites[i]+(88*(j));
			if (i&1)
			SpriteX8_OR_R(0,0,1,(unsigned char*)color_perso[j-3],22*2,address+44);			
			if ((i&0b10)==0b10)
			SpriteX8_OR_R(0,0,1,(unsigned char*)color_perso[j-3],22*2,address);
		}
	/*
	src:
	generated_sprites[i]+(88*3*2)
	dest:
	generated_sprites[i]+(88*0)
	size:
	3*44	
	*/
	SpriteX8_MIRROR_H(3*44,generated_sprites[i]+(88*3*2),2,generated_sprites[i]+(88*0));

		for (j=0;j<3;j++) {
			address=generated_sprites[i]+2*22*2*4*4+(24*3*j);
			if (i&1)
			SpriteX8_OR_R(0,0,1,(unsigned char*)&death_sprites_colors[42*j],14*3,address+216);			
			if ((i&0b10)==0b10)
			SpriteX8_OR_R(0,0,1,(unsigned char*)&death_sprites_colors[42*j],14*3,address);
		}		
	}
}


/*********************************************************************************************************
 *	Draws a tile...
 *********************************************************************************************************/
void draw_tile(short x, short y, short type) {
	//GraySprite16_RPLC_R(convertx(x),converty(y),16,&S_tile[type<<5],&S_tile[(type<<5)+16],virtual[LIGHT2],virtual[DARK2]);
	GrayTile16x16_RPLC_R(x,converty(y),&S_tile[type<<5],&S_tile[(type<<5)+16],virtual[LIGHT2],virtual[DARK2]);

}


/*********************************************************************************************************
 *	Draws the masked igloos.
 *********************************************************************************************************/
void draw_igloos() {
	GrayTile16x16_MASK_R(3,4*16,igloo_MT,&igloo_MT[16],igloo_MT_mask,igloo_MT_mask,virtual[LIGHT1],virtual[DARK1]);
	GrayTile16x16_MASK_R(3,5*16,igloo_MM,&igloo_MM[16],igloo_MM_mask,igloo_MM_mask,virtual[LIGHT1],virtual[DARK1]);
	GrayTile16x16_MASK_R(3,6*16,igloo_MD,&igloo_MD[16],igloo_MD_mask,igloo_MD_mask,virtual[LIGHT1],virtual[DARK1]);
	GrayTile16x16_MASK_R(2,5*16,igloo_L,&igloo_L[16],igloo_L_mask,igloo_L_mask,virtual[LIGHT1],virtual[DARK1]); 
  GrayTile16x16_MASK_R(4,5*16,igloo_R,&igloo_R[16],igloo_R_mask,igloo_R_mask,virtual[LIGHT1],virtual[DARK1]); 
  GrayTile16x16_MASK_R(7,8*16,igloo_MT,&igloo_MT[16],igloo_MT_mask,igloo_MT_mask,virtual[LIGHT1],virtual[DARK1]);
  GrayTile16x16_MASK_R(7,9*16,igloo_MM,&igloo_MM[16],igloo_MM_mask,igloo_MM_mask,virtual[LIGHT1],virtual[DARK1]);
  GrayTile16x16_MASK_R(7,10*16,igloo_MD,&igloo_MD[16],igloo_MD_mask,igloo_MD_mask,virtual[LIGHT1],virtual[DARK1]);
  GrayTile16x16_MASK_R(6,9*16,igloo_L,&igloo_L[16],igloo_L_mask,igloo_L_mask,virtual[LIGHT1],virtual[DARK1]); 
  GrayTile16x16_MASK_R(8,9*16,igloo_R,&igloo_R[16],igloo_R_mask,igloo_R_mask,virtual[LIGHT1],virtual[DARK1]); 
}

/*********************************************************************************************************
 *	Routine to draw the teletransporting player.
 *********************************************************************************************************/

void draw_tele_player(short p) {
	short frame = player[p].t_frame;
	short real_step=(player[p].step==3)+(player[p].step&1);
	char* address=(generated_sprites[p]+real_step*88+player[p].dir*88*3+(frame<<1));
	GraySprite16_MASK(
	player[p].x,
	player[p].y-1,
	PERSO_SPRITE_HEIGHT-frame,
	(short*)address,
  (short*)address+22,
	S_persomask[player[p].dir*3+real_step],
	S_persomask[player[p].dir*3+real_step],
	virtual[DARK1],
 	virtual[LIGHT1]);	
}


/*********************************************************************************************************
 *	Routine to draw the dying player (3 frames in wich the player falls to the ground).
 *********************************************************************************************************/
 

void draw_the_falling_block(short x, short y) {
	//draw_tile(x,y,hard_block);
	if (y>0)
	GraySprite16_RPLC_R(convertx(x),y,16,&S_tile[hard_block<<5],&S_tile[(hard_block<<5)+16],virtual[LIGHT1],virtual[DARK1]);
}



/*********************************************************************************************************
 *	Routine to draw the dying player (3 frames in wich the player falls to the ground).
 *********************************************************************************************************/
 
void draw_dying_player(short p) {
	short pp=p;
	char* address=(generated_sprites[pp]+2*22*2*4*4);
	GraySpriteX8_MASK(
		player[p].x-1,
		player[p].y-5-1,
		DYING_PERSO_HEIGHT,
		address+((player[p].death_frame)<<3)*9,
		address+((player[p].death_frame)<<3)*9+216,
		&death_sprites_mask[((player[p].death_frame)<<3)*9],
		&death_sprites_mask[((player[p].death_frame)<<3)*9],
		DYING_PERSO_BYTE_WIDTH,
		virtual[DARK1],
		virtual[LIGHT1]);
		
	player[p].interstep++;
	
	if (player[p].interstep == 6+((player[p].death_frame==2)*40)) {
		player[p].interstep = 0;
		player[p].death_frame++;
		if (player[p].death_frame == 3)
		player[p].is_drawn = FALSE;
	}	
}



/*********************************************************************************************************
 *	Draws a string (in 'F_16x20', with a white bordure, and centered !)
 *********************************************************************************************************/
void draw_sexy_string(char* str) {
	char mini_buffer[10];
	char large_buffer[40];
	short string_offset_x = (160-((strlen(str)-1)<<4))>>1;
	short string_offset_y = 40+screen_offset_y/30;
	static char x[8] = {1,1,0,-1,-1,-1,0,1};
	static char y[8] = {0,1,1,1,0,-1,-1,-1};
	short j=0,i=0;
	FontSetSys(F_8x10);
	while (str[j] != '\0') {
		memset(mini_buffer,0,10);
		PortSet(mini_buffer,7,9);
		DrawChar (0,0, str[j], A_REVERSE);	
		DoubleSpriteDimensionsX8_R(10,mini_buffer,1,large_buffer);
		for (i=8;i--;) {
			GraySprite16_AND(string_offset_x+(j<<4)+x[i],string_offset_y+y[i],20,(short*)large_buffer,(short*)large_buffer,virtual[LIGHT1],virtual[DARK1]);
		}
		memset(mini_buffer,0,10);
		PortSet(mini_buffer,7,9);
		DrawChar (0,0, str[j], A_NORMAL);
		DoubleSpriteDimensionsX8_R(10,mini_buffer,1,large_buffer);
		GraySprite16_OR(string_offset_x+(j<<4),string_offset_y,20,(short*)large_buffer,(short*)large_buffer,virtual[LIGHT1],virtual[DARK1]);		
		j++;
	}
}


/*********************************************************************************************************
 *	Draws a player according to its properties (sick, ghost, step, direction)
 *********************************************************************************************************/
void draw_player(short p) {
	if (player[p].sick!=FALSE) {
		player[p].sick_time--;
		if (player[p].sick_time == 1) {
			player[p].sick = FALSE;
			if ((player[p].x&1)	== 1)
			player[p].x++;
			if ((player[p].y&1)	== 0)
			player[p].y++;		
		}
	}
	//short pp=p;
		short real_step=(player[p].step==3)+(player[p].step&1);
	char* address=(generated_sprites[p]+real_step*88+player[p].dir*88*3);
	
	
	if (player[p].is_being_teletransported == TRUE) {
		short  frame = player[p].t_frame;
		GraySprite16_MASK(
		player[p].x,
		player[p].y-1+frame,
		PERSO_SPRITE_HEIGHT-frame,
		(short*)address+(frame),
	  (short*)address+22+(frame),
		S_persomask[player[p].dir*3+real_step]+frame,
		S_persomask[player[p].dir*3+real_step]+frame,
		virtual[DARK1],
	 	virtual[LIGHT1]);
	 	
	 	GraySprite16_MASK(
		player[p].x,
		player[p].y-4+frame,
		7,
		ring_transporter_dark,
	  ring_transporter_light,
		ring_mask,
		ring_mask,		
		virtual[DARK1],
	 	virtual[LIGHT1]);	
	 	return;
	}
	
	if (player[p].is_a_ghost == TRUE) {
		player[p].time_ghost--;
		if (player[p].time_ghost <= 0)
		player[p].is_a_ghost = FALSE;
		if (player[p].time_ghost > 90 || (player[p].time_ghost%10)<5) {
			GraySprite16_OR_R (
			player[p].x,
			player[p].y-1,
			PERSO_SPRITE_HEIGHT,
			(short*)address,
		  (short*)address+22,
			virtual[DARK1],
		 	virtual[LIGHT1]);
		 	return;
		} 	
	}
	if (player[p].sick!=FALSE && (player[p].sick_time%10)<5)	 {
	 	
	 	//I generate the inverse of the mask in real time.

	 	unsigned short g_s[PERSO_SPRITE_HEIGHT];	//The inverse of the sprite...
	 	short i=PERSO_SPRITE_HEIGHT;	 	
	 	short *k=S_persomask[player[p].dir*3+real_step];
	 	for (;i--;) {
	 		g_s[i] = ~(*(k+i));
	 	}
	 	
	 	GraySprite16_OR_R (
		player[p].x,
		player[p].y-1,
		PERSO_SPRITE_HEIGHT,
		g_s,
		g_s,
		virtual[DARK1],
	 	virtual[LIGHT1]);	 	

 	}
 	else
 	{
		GraySprite16_MASK(
		player[p].x,
		player[p].y-1,
		PERSO_SPRITE_HEIGHT,
		(short*)address,
	  (short*)address+22,
		S_persomask[player[p].dir*3+real_step],
		S_persomask[player[p].dir*3+real_step],
		virtual[DARK1],
	 	virtual[LIGHT1]);
 	}
}


/*********************************************************************************************************
*		Draws the status bar at the bottom of the screen.
*********************************************************************************************************/
void draw_status() {
	short ti92_offset = (CALCULATOR>0)*28*30;
	memset(GrayGetPlane(1)+90*30+ti92_offset,0b11111111,30);
	memset(GrayGetPlane(0)+90*30+ti92_offset,0b11111111,30);
	memset(GrayGetPlane(0)+91*30+ti92_offset,0,30*8);
	memset(GrayGetPlane(1)+91*30+ti92_offset,0,30*8);	
	GrayTile8x8_RPLC_R(0,91,&status[s_inter1<<3],&status[s_inter2<<3],GrayGetPlane(DARK_PLANE)+ti92_offset,GrayGetPlane(LIGHT_PLANE)+ti92_offset);
	GrayTile8x8_RPLC_R(1,91,&status[s_bomb<<3],&status[s_bomb<<3],GrayGetPlane(0)+ti92_offset,GrayGetPlane(1)+ti92_offset);
	GrayTile8x8_RPLC_R(2,91,&numbers[player[playernum].number_of_bomb<<3],&numbers[player[playernum].number_of_bomb<<3],GrayGetPlane(0)+ti92_offset,GrayGetPlane(1)+ti92_offset);
	GrayTile8x8_RPLC_R(3,91,&status[s_inter1<<3],&status[s_inter2<<3],GrayGetPlane(DARK_PLANE)+ti92_offset,GrayGetPlane(LIGHT_PLANE)+ti92_offset);
	GrayTile8x8_RPLC_R(4,91,&status[s_power<<3],&status[s_power<<3],GrayGetPlane(0)+ti92_offset,GrayGetPlane(1)+ti92_offset);
	GrayTile8x8_RPLC_R(5,91,&numbers[(player[0].power)<<3],&numbers[(player[0].power)<<3],GrayGetPlane(0)+ti92_offset,GrayGetPlane(1)+ti92_offset);
	GrayTile8x8_RPLC_R(6,91,&status[s_inter1<<3],&status[s_inter2<<3],GrayGetPlane(DARK_PLANE)+ti92_offset,GrayGetPlane(LIGHT_PLANE)+ti92_offset);	
	short i,offset=0;
	for (i=4;i--;) {
		if (player[i].is_playing == TRUE) {
			offset = 8+(i*3);
			GrayTile8x8_RPLC_R(offset,91,&status[s_bdude_l<<3],&status[s_bdude_d<<3],GrayGetPlane(LIGHT_PLANE)+ti92_offset,GrayGetPlane(DARK_PLANE)+ti92_offset);
			if (i&1)
			Tile8x8_OR_R(offset,91,&status[s_bdude_color<<3],GrayGetPlane(LIGHT_PLANE)+ti92_offset);
			if ((i&0b10)==0b10)
			Tile8x8_OR_R(offset,91,&status[s_bdude_color<<3],GrayGetPlane(DARK_PLANE)+ti92_offset);
			GrayTile8x8_RPLC_R(offset+1,91,&numbers[player[i].num_of_vic<<3],&numbers[player[i].num_of_vic<<3],GrayGetPlane(0)+ti92_offset,GrayGetPlane(1)+ti92_offset);
		}
	}
	memset(GrayGetPlane(1)+99*30+ti92_offset,0b11111111,30);
	memset(GrayGetPlane(0)+99*30+ti92_offset,0b11111111,30);
}


/*********************************************************************************************************
*		Draw the tiles that have changed in the background (this includes explosions, bombs and teletransporter).
*********************************************************************************************************/
void animate_background() {
	short x,y;
  if (level == l_EJC && random(10)==0) {
  	y=random(LEVEL_HEIGHT-2)+1;
    x=random(LEVEL_WIDTH-2)+1;	
   	if (maps[m_solid][x][y]==FALSE && maps[m_time][x][y] == 0) {
			maps[m_animated_tile][x][y]=nuage1;
			maps[m_time][x][y] = 1;
			GrayTile16x16_MASK_R(
						x,
						converty(y),
						&S_animated_tile[maps[m_animated_tile][x][y]<<5],
						&S_animated_tile[(maps[m_animated_tile][x][y]<<5)+16],
						&S_animated_tile_mask[maps[m_animated_tile][x][y]<<4],
						&S_animated_tile_mask[maps[m_animated_tile][x][y]<<4],
						virtual[LIGHT2],
						virtual[DARK2]);
		}
	}
  short time=0,type=0; 
  short redraw_tile=FALSE;
  for (y = LEVEL_HEIGHT; y -- ;) {
 		for (x = LEVEL_WIDTH; x --;) {
   		redraw_tile=0;
   		if (maps[m_time][x][y] != 0) {
   			maps[m_time][x][y]++;
   			time = maps[m_time][x][y];
				type =  maps[m_animated_tile][x][y];
				/*
				Bomb animation
				*/
				if (type == bomb_large && time == 10) {
					maps[m_animated_tile][x][y] = bomb_small;
					maps[m_time][x][y] = 1;
					redraw_tile = TRUE;
				}
				if (type == bomb_small && time == 10) {
					maps[m_animated_tile][x][y] = bomb_large;
					maps[m_time][x][y] = 1;
					redraw_tile = TRUE;
				}
				/*
				Explosion Animation
				*/
				animate_explosion(x,y,h_1,h_6,&redraw_tile);
				animate_explosion(x,y,hl_1,hl_6,&redraw_tile);				
				animate_explosion(x,y,hr_1,hr_6,&redraw_tile);
				animate_explosion(x,y,v_1,v_6,&redraw_tile);
				animate_explosion(x,y,vu_1,vu_6,&redraw_tile);				
				animate_explosion(x,y,vd_1,vd_6,&redraw_tile);				
				animate_explosion(x,y,c_1,c_6,&redraw_tile);	

				/*
				Block's explosion animation
				*/
				if (type >= exploding_block && type <= exploding_block+4 && time == 6) {
					maps[m_animated_tile][x][y]++;
					maps[m_time][x][y] = 1;
					maps[m_static_tile][x][y] = maps[m_trans][x][y];		
					if (maps[m_animated_tile][x][y] == exploding_block+4) {
						maps[m_solid][x][y] = FALSE;
						delete_animated_tile(x,y);
						if (random(2)) {				
							maps[m_animated_tile][x][y] = nuage1;
							maps[m_time][x][y]=1;
							redraw_tile = TRUE;
						}
					}
					else {
						redraw_tile = TRUE;
					}
				}				
				//Cloud animation (right before the creation of the bonus)				
				if (type >= nuage1 && type <= nuage4 && time == 6) {
					maps[m_time][x][y] = 1;
					maps[m_animated_tile][x][y]++;
					if (maps[m_animated_tile][x][y] == nuage4+1)
					maps[m_animated_tile][x][y]=bonus1+/*10;//*/(random(number_bonus)<<1);
					redraw_tile = TRUE;
				}
				/*
				Blocks's endless animation's
				*/
				if (type >= rotating_block_1 && type <= rotating_block_4 && time == 5) {
					maps[m_time][x][y] = 1;
					redraw_tile = TRUE;					
					maps[m_animated_tile][x][y]++;
					if (maps[m_animated_tile][x][y] == rotating_block_4+1)
						maps[m_animated_tile][x][y] = rotating_block_1;
				}
				

				/*
				Teletransporter endless animation
				*/
				if (type >= trans_1 && type <= trans_6 && time == 3) {
					maps[m_time][x][y] = 1;
					redraw_tile = TRUE;					
					maps[m_animated_tile][x][y]++;
					if (maps[m_animated_tile][x][y] == trans_6+1)
					maps[m_animated_tile][x][y] = trans_1;	
				}
				/*
				Bonus's endless animation's
				*/
				if (type >= bonus1 && type <= bonus7b && time == 16) {
					maps[m_time][x][y] = 1;
					redraw_tile = TRUE;					
					if ((type&1) == (bonus1&1)) {
						maps[m_animated_tile][x][y]++;
					}
					else
					{
						maps[m_animated_tile][x][y]--;
					}			
				}
				//only draw the visible or nearly-visible tiles! (speed gain!)
				if (redraw_tile == TRUE && y >= (screen_offset_y/30)>>4 && y<= ((screen_offset_y/30))+8*16) {
					if (maps[m_animated_tile][x][y] < rotating_block_1) {
						draw_tile(x,y,maps[m_static_tile][x][y]);
						GrayTile16x16_MASK_R(
						x,
						converty(y),
						&S_animated_tile[maps[m_animated_tile][x][y]<<5],
						&S_animated_tile[(maps[m_animated_tile][x][y]<<5)+16],
						&S_animated_tile_mask[maps[m_animated_tile][x][y]<<4],
						&S_animated_tile_mask[maps[m_animated_tile][x][y]<<4],
						virtual[LIGHT2],
						virtual[DARK2]);
					}
					else
					{
						GrayTile16x16_RPLC_R(
						x,
						converty(y),
						&S_animated_tile[maps[m_animated_tile][x][y]<<5],
						&S_animated_tile[(maps[m_animated_tile][x][y]<<5)+16],
						virtual[LIGHT2],
						virtual[DARK2]);
					}
				}				
			}
   	}
	}	
}



/*********************************************************************************************************
*		This routines draw the whole map in the background buffer and initialize a few var according 
*		to the map (respawn points for instance).
*********************************************************************************************************/

static short mm[LEVEL_WIDTH][LEVEL_HEIGHT]={

	{0,0,0,0,0,0,0,0,0,0,0,0,0,0},	
	{0,0,bonus3,bonus2b,bonus1,0,0,0,0,0,bonus1,bonus2b,bonus3,0,0},
	{0,bonus3,bonus3,bonus2b,bonus1,0,0,0,0,0,bonus1,bonus2b,bonus3,bonus3,0},
	{0,bonus2b,bonus2b,bonus2b,bonus1,0,0,0,0,0,bonus1,bonus2b,bonus2b,bonus2b,0},
	{0,bonus1,bonus1,bonus1,bonus1,0,0,0,0,0,bonus1,bonus1,bonus1,bonus1,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0},	
	{0,bonus1,bonus1,bonus1,bonus1,0,0,0,0,0,bonus1,bonus1,bonus1,bonus1,0},
	{0,bonus2b,bonus2b,bonus2b,bonus1,0,0,0,0,0,bonus1,bonus2b,bonus2b,bonus2b,0},
	{0,bonus3,bonus3,bonus2b,bonus1,0,0,0,0,0,bonus1,bonus2b,bonus3,bonus3,0},	
	{0,0,bonus3,bonus2b,bonus1,0,0,0,0,0,bonus1,bonus2b,bonus3,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0}};
	
	
void draw_background_in_buffer() {
  short x,y;
  short i,j;
	
  //If a custom map was chosed, then we must load it:
  if (link_on == FALSE || playernum == HOST_NUMBER) {	
		if (custom_lvl_number>=0) {
			copy_level(&level_array[l_CUSTOM]);
		}
	}
	
	for (i=240;i--;) {
		memset((char*)(virtual[LIGHT2])+30*i,~(1<<(i%8)),30);
		memset((char*)(virtual[DARK2])+30*i,(0b10000000>>(i%8)),30);
	}
	
  
  soft_block = level_array[level].soft_block;
 	exploding_block = level_array[level].exploding_block;
  hard_block = level_array[level].hard_block;
  level_num=level;

  for (i=16;i--;) {
  	transporterr[i]=level_array[level].transporter_coord[i];
  }

  short type;
	
  


  
  
  for (y = LEVEL_HEIGHT; y --; ) {
 		for (x = LEVEL_WIDTH; x-- ;) {
			maps[m_animated_tile][x][y] = (level == l_BEACH)*mm[x][y];			
			maps[m_time][x][y] = (maps[m_animated_tile][x][y] != 0);
			maps[m_solid][x][y] = FALSE;	   		
			maps[M_DANGER_AI][x][y] = 0;

			maps[m_static_tile][x][y] = level_array[level].map[y][x];
			maps[m_trans][x][y] = 0;	
			maps[m_trans][x][y] = maps[m_static_tile][x][y];



			if (level_array[level].map[y][x] == transporter) {
				maps[m_time][x][y] = 2;
				maps[m_animated_tile][x][y] = trans_1;	
			}		

			


			type = maps[m_static_tile][x][y];
      if (hard_or_not_hard[type] == FALSE && CHANCE_TO_BE_A_SOFT_BLOCK && level != l_power && level != l_fith && level != l_EJC && type != space_empty && level != l_BEACH) {
      	for (j=0;j<16;j+=2) {
      	if (
	      		(level_array[level].transporter_coord[j] == x && level_array[level].transporter_coord[j+1] == y) ||
		      	(level_array[level].transporter_coord[j] == x-1 && level_array[level].transporter_coord[j+1] == y) ||
		      	(level_array[level].transporter_coord[j] == x+1 && level_array[level].transporter_coord[j+1] == y) ||
		      	(level_array[level].transporter_coord[j] == x && level_array[level].transporter_coord[j+1] == y-1) ||
		      	(level_array[level].transporter_coord[j] == x && level_array[level].transporter_coord[j+1] == y+1)) {
	      		j=100;
	      		break;
      		}
      	}
				for (i=4;i--;) {
	      	spawnx[i]=level_array[level].spawn_x[i]>>4;
	       	spawny[i]=(level_array[level].spawn_y[i]+5)>>4;     	
				}
      	if (j!=100) {
	      	for (j=4;j--;) {
	      	if (
	      		(spawnx[j] == x && spawny[j] == y) ||
		      	(spawnx[j] == x-1 && spawny[j] == y) ||
		      	(spawnx[j] == x+1 && spawny[j] == y) ||
		      	(spawnx[j] == x && spawny[j] == y-1) ||
		      	(spawnx[j] == x && spawny[j] == y+1)) {
	      		j=100;
	      		break;
	      		}
	      	}
	      }
      	if (j!=100)
      	type = soft_block;
      }
      if ((x<4 || x>6 || y<3 || y>11) && hard_or_not_hard[type] == FALSE && level == l_fith) {
      	type = soft_block;
      	if (random(4)==1)
      	type = hard_block;
      }
      
			if (type == round_block) {
				maps[m_time][x][y] = 2;
				maps[m_animated_tile][x][y] = rotating_block_1;		
			}
			
			if (level == l_BEACH && random(30)==0)
			type = sol_alternate_plage;
			
			draw_tile(x,y,type);
					
    	maps[m_solid][x][y] = hard_or_not_hard[type];
    	maps[m_static_tile][x][y] = type;

   	}
	}
	
	for (i=4;i--;) {
  	spawnx[i]=level_array[level].spawn_x[i];
  	spawny[i]=level_array[level].spawn_y[i];     	
	}
}


/*********************************************************************************************************
*		This routines is called once for every segment of an explosion
*********************************************************************************************************/
void explose_tile(short x, short y, short type,  short *letter) {
	if (x<0 || x>LEVEL_WIDTH-1 || y<0 || y>LEVEL_HEIGHT-1) {
		*letter=0;//FALSE;
		return;
	}
	
	if (maps[m_solid][x][y]==FALSE && (maps[m_animated_tile][x][y] < c_1 || maps[m_animated_tile][x][y] > c_6)) {
		maps[m_animated_tile][x][y] = type;
		maps[m_time][x][y] = 1;
	}
	else
	{
		if (maps[m_static_tile][x][y]==soft_block) {
			
			maps[m_animated_tile][x][y] = exploding_block;
			maps[m_time][x][y] = 1;
			GrayTile16x16_RPLC_R(
				x,
				converty(y),
				&S_animated_tile[exploding_block<<5],
				&S_animated_tile[(exploding_block<<5)+16],
				virtual[LIGHT2],
				virtual[DARK2]);
		}
		if ((maps[m_animated_tile][x][y] == bomb_small || maps[m_animated_tile][x][y] == bomb_large) && hard_or_not_hard[maps[m_static_tile][x][y]] == 0) {
			short i=0;
			while (bombs[i].x != x || bombs[i].y != y ) {
				i++;
			}
			bombs[i].time = 3;			
		}
		*letter=0;//FALSE;
	}
}

