// C Source File
// Created 3/5/2004; 8:28:50 PM
#include <tigcclib.h>
#include "extgraph.h"
#include "OrageGL.h"
#include "define.h"
#include "structures.h"
#include "globals.h"
#include "hard.h"


/*********************************************************************************************************
 *	Function prototypes
 *********************************************************************************************************/
//Main.c
void move_player(short);
void testmove(short*, short*,short);
static inline void copy_virtual_to_screen(short);
static inline void copy_buffer_to_virtual(void);
void change_danger_level(short);
short drop_a_bomb(short);
//Link.c
short call_other_calc(void);
void send_and_receive_data(void);
short Wait_2nd_Player(void);
//Draw.c:
void draw_tile(short , short , short);
void draw_player(short);
void draw_the_falling_block(short, short);
void draw_status();
void animate_background(void);
void draw_background_in_buffer(void);
void explose_tile(short , short, short, short *);
void draw_dying_player(short);
void draw_sexy_string(char *);
void draw_igloos(void);
void generate_the_sprites(void);
void vertical_string(char *, short , short);
//menu.c
short menu(void);
//ai.c
//stat move_ai(short);
//pref.c
void read_data(PREF_STRUCT*);
void write_data(PREF_STRUCT*);
//endofgame.c:
void end_of_game(short);
//transition.c
void crossing_transition(void);


/*********************************************************************************************************
 *	Globals used here
 *********************************************************************************************************/
short fast_quit;
char* buffer;
PLAYA player[6];
void* virtual[5];
BOMB* bombs;
//map[map_number][x][y]
short (*maps)[LEVEL_WIDTH][LEVEL_HEIGHT];
char *generated_sprites[4];
short screen_offset_y,screen_offset_x;
short transporterr[16];
short level;
short link_on;
short use_USB;
short number_of_ennemies;
short playernum,otherplayernum;
short number_bonus;
short hard_block;
short soft_block;
short exploding_block;
AI ai[4];
short	spawnx[4];
short	spawny[4];
short calc_num;
enum calcs {is_TI89,is_TI92,is_V200};


/*
To make the game oncalc compatible with different keys.
*/
KEY put_bomb[3]={{0,4},//2nd	(Ti89)
								{6,4},//F1	(Ti92)
								{0,3}};//Hand (V200)
KEY put_line[3]={{0,6},//Diamond	(Ti89)
								{4,4},//F2	(Ti92)
								{9,3}};//Q (V200)


/*
The "Volatile" keywords prevents the compiler from making unwanted 
optimizations with those variables because he doesn't know when these values can be changed..
*/
volatile short Mseconds;
volatile short end_of_timer;

/*
My handler. Comes from Excite Bike (or Ice Hockey, dunno).
*/
DEFINE_INT_HANDLER (CLOCK_TIMER) {
	Mseconds+=Mseconds<DELAY;
	end_of_timer=Mseconds!=DELAY;
	if (!end_of_timer) {
		OSRegisterTimer (3,0);
	}

}



/*********************************************************************************************************
 *	Returns a tile-related number: if it is solid or it is a dangerous tile, it returns 1
 *********************************************************************************************************/
short no_AI_land(short x, short y) {
	return(maps[m_solid][x][y]!= FALSE || maps[M_DANGER_AI][x][y]!=0);
}



/*********************************************************************************************************
 *	Returns 1 if the AI can find a path to hide (i.e. be in a non-dangerous tile). 
 *	This function also sets the direction he AI will go if she has to hide.
 *********************************************************************************************************/
static inline short AI_is_in_explosion(short x, short y, short *vx, short * vy) {
	if (no_AI_land(x-1,y) && no_AI_land(x+1,y) && no_AI_land(x,y-1) && no_AI_land(x,y+1)) {
		//the AI is stuck...
		short i=1,
				a=FALSE,
				b=FALSE,
				c=FALSE,
				d=FALSE;
				/*
						a
					c		d
						b
				*/
		while (a+b+c+d < 4*TRUE) {//		(...)
			if (maps[m_solid][x][y-i] != FALSE || a == TRUE) {
				a = TRUE;
			}
			else {
				if (no_AI_land(x-1,y-i)==FALSE || no_AI_land(x+1,y-i)==FALSE || no_AI_land(x,y-i)==FALSE) {
					*vx=0;
					*vy=-16;
					return(TRUE);
				}
			}
			if (maps[m_solid][x][y+i] != FALSE || b == TRUE) {
				b = TRUE;
			}
			else {
				if (no_AI_land(x-1,y+i)==FALSE || no_AI_land(x+1,y+i)==FALSE || no_AI_land(x,y+i)==FALSE) {
					*vx=0;
					*vy=16;
					return(TRUE);
				}
			}
			if (maps[m_solid][x-i][y] != FALSE || c == TRUE) {
				c = TRUE;
			}
			else {
				if (no_AI_land(x-i,y-1)==FALSE || no_AI_land(x-i,y+1)==FALSE || no_AI_land(x-i,y)==FALSE) {
					*vx=-16;
					*vy=0;
					return(TRUE);
				}
			}
			if (maps[m_solid][x+i][y] != FALSE || d == TRUE) {
				d = TRUE;
			}
			else {
				if (no_AI_land(x+i,y-1)==FALSE || no_AI_land(x+i,y+1)==FALSE || no_AI_land(x+i,y)==FALSE) {
					*vx=16;
					*vy=0;
					return(TRUE);
				}
			}	
			i++;
		}
	}
	return(FALSE);
}






/*********************************************************************************************************
 *	Returns 1 if the AI can find a path to hide (i.e. be in a non-dangerous tile).
 *********************************************************************************************************/
static inline short AI_can_hide(short n) {

	short array[LEVEL_WIDTH][LEVEL_HEIGHT];
	/*
	Right here I save the real data
	*/
	memcpy(array,maps[M_DANGER_AI],LEVEL_WIDTH*LEVEL_HEIGHT*2);
	short x = (player[n].x+8)>>4;
	short y = (player[n].y+10)>>4;
	short old_solid_state = maps[m_solid][x][y];
	maps[m_solid][x][y] = TRUE;
	
	bombs[33].x = x;
	bombs[33].y = y;
	bombs[33].size = player[n].power;
	/*
	Right here I simulate the the fact that the AI just put a bomb
	*/
	change_danger_level(33);
	/*
	Now I can if putting a bomb is dangerous to the AI
	*/
	short i=1,
	a=FALSE,
	b=FALSE,
	c=FALSE,
	d=FALSE,
	XX=FALSE;
		
		while (a+b+c+d < 4*TRUE && XX == FALSE) {
			if (maps[m_solid][x][y-i] != FALSE || a == TRUE) {
				a = TRUE;
			}
			else {
				if (no_AI_land(x-1,y-i)==FALSE || no_AI_land(x+1,y-i)==FALSE || no_AI_land(x,y-i)==FALSE) {
					XX=TRUE;
				}
			}
			if (maps[m_solid][x][y+i] != FALSE || b == TRUE) {
				b = TRUE;
			}
			else {
				if (no_AI_land(x-1,y+i)==FALSE || no_AI_land(x+1,y+i)==FALSE || no_AI_land(x,y+i)==FALSE) {
					XX=TRUE;
				}
			}
			if (maps[m_solid][x-i][y] != FALSE || c == TRUE) {
				c = TRUE;
			}
			else {
				if (no_AI_land(x-i,y-1)==FALSE || no_AI_land(x-i,y+1)==FALSE || no_AI_land(x-i,y)==FALSE) {
					XX=TRUE;
				}
			}
			if (maps[m_solid][x+i][y] != FALSE || d == TRUE) {
				d = TRUE;
			}
			else {
				if (no_AI_land(x+i,y-1)==FALSE || no_AI_land(x+i,y+1)==FALSE || no_AI_land(x+i,y)==FALSE) {
					XX=TRUE;
				}
			}	
			i++;
		}
	maps[m_solid][x][y] = old_solid_state;
	/*
	Here I recall the real data
	*/
	memcpy(maps[M_DANGER_AI],array,LEVEL_WIDTH*LEVEL_HEIGHT*2);
	return(XX);
}




/*********************************************************************************************************
 *	This function returns TRUE if the area around x1,y1 is safe (this is required when dropping bombs)
 *********************************************************************************************************/
 /*
static inline short the_area_around_is_not_dangerous(short x, short y) {
	return(		(maps[M_DANGER_AI][x][y] == 0) &
						(maps[M_DANGER_AI][x+1][y] == 0) &
						(maps[M_DANGER_AI][x-1][y] == 0) &
						(maps[M_DANGER_AI][x][y+1] == 0) &
						(maps[M_DANGER_AI][x][y-1] == 0));
}
*/

static inline short the_area_around_is_not_dangerous(short x, short y) {
	return(		(maps[M_DANGER_AI][x][y] +
						maps[M_DANGER_AI][x+1][y] +
						maps[M_DANGER_AI][x-1][y] +
						maps[M_DANGER_AI][x][y+1] +
						maps[M_DANGER_AI][x][y-1]) == 0);
}




/*********************************************************************************************************
 *	This function moves the n'th AI, (this includes dropping bombs and hiding)
 *********************************************************************************************************/

static short dir_x[4] = {0,0,-1,1};
static short dir_y[4] = {-1,1,0,0};

static inline void move_ai(short n) {
	short vx=0,vy=0;
	short x=player[n].x;
	short y=player[n].y;
	short x1 = (x+8)>>4;
	short y1 = (y+10)>>4;

	if (x==ai[n].goal_x && y==ai[n].goal_y) {

		ai[n].old_goal_x = ai[n].goal_x;
		ai[n].old_goal_y = ai[n].goal_y;
		
		
		if (random(7) == TRUE && AI_can_hide(n) && maps[M_DANGER_AI][x1][y1] == 0 && the_area_around_is_not_dangerous(x1,y1)==TRUE) {
		
		 change_danger_level(drop_a_bomb(n));
		}
		
		short r=random(4+((!link_on)<<2));

		if (r>3) {
			if (random(2)==1) {
				r=1;
				if (player[n].y > player[playernum].y)
				r=0;			
			}
			else
			{
				r=3;
				if (player[n].x > player[playernum].x)
					r=2;				
			}	
		}
			
			
			

		if (no_AI_land(x1+dir_x[r],y1+dir_y[r]) == FALSE) {
			vy=(dir_y[r]<<4);
			vx=(dir_x[r]<<4);
		}


		//Lets test if the AI is 'stuck' in an explosion & between blocks; if so, move (towards a safe place if possible).
		if (vy==0 && vx==0 && maps[M_DANGER_AI][x1][y1] != 0) {
			//Ok, the AI is in trouble.
			AI_is_in_explosion(x1,y1,&vx,&vy);
		}
		
		
		ai[n].goal_y=y+vy;
		ai[n].goal_x=x+vx;
		
	}
	
	
	/*
	Set the direction of the player.
	*/
	if (ai[n].goal_y<y) {
		vy=-MOVE_VECTOR;
		player[n].dir =	DIR_UP;
	}
	if (ai[n].goal_y>y) {
		vy=MOVE_VECTOR;
		player[n].dir =	DIR_DOWN;
	}
	if (ai[n].goal_x<x) {
		vx=-MOVE_VECTOR;
		player[n].dir =	DIR_LEFT;
	}
	if (ai[n].goal_x>x) {
		vx=MOVE_VECTOR;
		player[n].dir =	DIR_RIGHT;
	}
	
	/*
	Collision detection; if a collision is detected, vx or vy is changed (note that the direction will not be affected).
	*/
	testmove(&vx,&vy,n);
	if (vx==0 && vy==0) {
		/*
		Usually, the above is true when a bomb is dropped right afront the AI. Since we don't want the IA to be 
		stuck, we tell her to go back where she came.
		*/
		ai[n].goal_y = ai[n].old_goal_y;
		ai[n].goal_x = ai[n].old_goal_x;
		
	}
	/*
	change the player's coord.
	*/
	player[n].x += vx;
	player[n].y += vy;
	
	
	
	if (vy != 0 || vx != 0) {
		player[n].interstep++;
	}
	else
	{
		player[n].interstep = 0;
  	player[n].step = 0;
	}
	
	if (player[n].interstep == NUM_OF_INTERSTEP) {
		player[n].interstep = 0;
		player[n].step++;
		if (player[n].step == NUM_OF_STEP)
		player[n].step = 0;
	}
	
}




//<-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><->
//<-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><->


void change_danger_level(short i) {

	short n,x=bombs[i].x,y=bombs[i].y,power=bombs[i].size;

	short xp,yp;
	short a=TRUE,
			b=TRUE,
			c=TRUE,
			d=TRUE;
			/*
				a
			c		d
				b
			*/
			
			
	maps[M_DANGER_AI][x][y]=TRUE;
	for (n=1;n<=power;n++) {
		
		
		xp=x-n;
		if (a==TRUE) {
			if (maps[m_solid][xp][y]!=FALSE) {
				if (xp<0) {
					a = FALSE;
				}
				else
				{
					if (maps[m_animated_tile][xp][y] == bomb_large || maps[m_animated_tile][xp][y] == bomb_small)
						maps[M_DANGER_AI][xp][y]=TRUE;
				}				
			}
			else {
				maps[M_DANGER_AI][xp][y]=TRUE;
			}
		}
		
		
		xp=x+n;
		if (b==TRUE) {
			if (maps[m_solid][xp][y]!=FALSE) {
				if (xp>=LEVEL_WIDTH) {
					b = FALSE;
				}
				else
				{
					if (maps[m_animated_tile][xp][y] == bomb_large || maps[m_animated_tile][xp][y] == bomb_small)
						maps[M_DANGER_AI][xp][y]=TRUE;
				}	
			}
			else {
				maps[M_DANGER_AI][xp][y]=TRUE;
			}
		}
		
		
		yp=y-n;
		if (c==TRUE) {
			if (maps[m_solid][x][yp]!=FALSE) {
				if (yp<0) {
					c = FALSE;
				}	
				else
				{		
					if (maps[m_animated_tile][x][yp] == bomb_large || maps[m_animated_tile][x][yp] == bomb_small)
						maps[M_DANGER_AI][x][yp]=TRUE;									
				}
			}
			else
			{
				maps[M_DANGER_AI][x][yp]=TRUE;
			}
		}
		
		
		
		yp=y+n;
		if (d==TRUE) {
			if (maps[m_solid][x][yp]!=FALSE) {
			 	if (yp>=LEVEL_HEIGHT) {
					d = FALSE;
				}
				else
				{
					if (maps[m_animated_tile][x][yp] == bomb_large || maps[m_animated_tile][x][yp] == bomb_small)
						maps[M_DANGER_AI][x][yp]=TRUE;
				}
			}
			else
			{
				maps[M_DANGER_AI][x][yp]=TRUE;	
			}	
		}
	}
}


//<-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><->
//<-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><->

short drop_a_bomb(short p) {
	short center_x = (player[p].x+8)>>4;
	short center_y = (player[p].y+10)>>4;
	if (maps[m_time][center_x][center_y] != 0 || hard_or_not_hard[maps[m_static_tile][center_x][center_y]] == TRUE || player[p].number_of_bomb_left==0)
	return(0);	
	player[p].number_of_bomb_left--;
	short i=0;
	while (bombs[i].on == TRUE) {i++;};
	bombs[i].on = TRUE;
	bombs[i].time = 100-50*(player[p].sick==si_hyperactivity)+50*(player[p].sick==si_lethargy);
	bombs[i].x = center_x;
	bombs[i].y = center_y;
	bombs[i].size = player[p].power;
	bombs[i].player = p;
	maps[m_solid][center_x][center_y] = TRUE;
	maps[m_animated_tile][center_x][center_y] = bomb_large;
	maps[m_time][center_x][center_y] = 9;
	if (p==playernum)
	draw_status();
	return(i);
}

//<-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><->
//<-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><->

void delete_animated_tile (short x, short y) {
	maps[m_animated_tile][x][y] = 0;
	maps[m_time][x][y] = 0;
	draw_tile(x,y,maps[m_static_tile][x][y]);
	if (maps[m_trans][x][y]==transporter) {
		maps[m_animated_tile][x][y] =	trans_1;
		maps[m_time][x][y] = 2;
	}
}

//<-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><->
//<-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><->

void animate_explosion(short x, short y, short typeA, short typeB, short *redraw_tile) {
	if (maps[m_animated_tile][x][y] >= typeA &&  maps[m_animated_tile][x][y] <= typeB && maps[m_time][x][y] == 4) {
		maps[m_animated_tile][x][y]++;
		if (maps[m_animated_tile][x][y] == typeB+1) {
			delete_animated_tile(x,y);
		}
		else {
			maps[m_time][x][y] = 1;		
			*redraw_tile = TRUE;
		}
	}
}

//<-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><->
//<-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><->

static inline void create_explosion(short x, short y, short powa) {
	short n,z;
	short a=TRUE,b=TRUE,c=TRUE,d=TRUE;
	/*
	Offset used to handle the special sprites at the end of each explosion
	*/
	short offset1[2]={0,18};//{0,12};
	short offset2[2]={0,24};//{0,16};	
	short offset3[2]={0,30};//{0,20};	
	/*
			a
		b		d
			c
	*/
	for (n=1;n<=powa;n++) {
		z=(n==powa);
		if (b) {
				explose_tile(x-n,y,h_1+offset1[z],&b);
		}
		if (d) {
				explose_tile(x+n,y,h_1+offset2[z],&d);
		}
		if (a) {
			explose_tile(x,y-n,v_1+offset2[z],&a);
		}
		if (c) {
				explose_tile(x,y+n,v_1+offset3[z],&c);
		}
	}	
	maps[m_animated_tile][x][y] = c_1;
	maps[m_time][x][y] = 1;
}

/*********************************************************************************************************
 * Function where the bombs are animated, where they explode and where I calculate the dangerous zones for the AI
 *********************************************************************************************************/

static inline void update_bombs()  {
	short i;
	short x=0,y=0;
	
	//The noob way:
	/*
	for (x=LEVEL_WIDTH;x--;) {
		for (y=LEVEL_HEIGHT;y--;) {
			maps[M_DANGER_AI][x][y] = 0;
		}
	}*/
	memset(maps[M_DANGER_AI],0,LEVEL_WIDTH*LEVEL_HEIGHT*sizeof(short));
	for (i=MAX_NUM_OF_BOMB-1;i--;) {
		if (bombs[i].on == TRUE) {
			bombs[i].already_processed = FALSE;
			bombs[i].time--;
			if (bombs[i].time == 0) {
				x=bombs[i].x;
				y=bombs[i].y;
				maps[m_time][x][y] = 0;
				maps[m_solid][x][y] = FALSE;
				create_explosion(x,y,bombs[i].size);	
				draw_tile(x,y,maps[m_static_tile][x][y]);		
			}
			if (bombs[i].time == -(EXPLOSION_TIME)) {
				bombs[i].on = FALSE;
				player[bombs[i].player].number_of_bomb_left++;
				draw_status();
			}
		}
	}
	
	
	for (x=8;x--;) {	//8 iterations, thats a lot !
		for (i=MAX_NUM_OF_BOMB;i--;) {	
			if (bombs[i].already_processed == FALSE && bombs[i].on == TRUE && (bombs[i].time < 40 || maps[M_DANGER_AI][bombs[i].x][bombs[i].y] == TRUE)) {
				change_danger_level(i);
				bombs[i].already_processed = TRUE;
			}
		}
	}
	
	
}


/*********************************************************************************************************
 *	Kills a player...
 *********************************************************************************************************/
void kill_player(short n) {
	player[n].is_dying = TRUE;
	player[n].is_playing = FALSE;
	draw_status();
	player[n].death_frame = 0;
	player[n].interstep = 0;
}


/*********************************************************************************************************
 *	This important function is the one that detects what is happening to the player:
 *	1/is he in an explosion ? 		2/is he on a bonus ? 				3/is he on a teletransporter ?			4/is he on the edge of the map ?			5/is stuck in a block (because of the ghost mode) ?
 *
 *	It then modify the player's properties according to the situation:
 *	1/the player is now dead			2/can put more bomb or...		3/move the player to a new position 4/...			5/...
 *********************************************************************************************************/
void on_what_is_the_player(short n,short fx, short fy) {
	short i;
	/*
	Convert the player screen-coordinate in an array coordinate.
	*/
	short x=(player[n].x+8)>>4;
	short y=(player[n].y+12)>>4;
	short type=maps[m_animated_tile][x][y];
	short time = maps[m_time][x][y];
	
	/*
	Test if the player is in an explosion or just received a block on his head ^^:
	*/
	if ((type >= h_1 && type <= vd_4 && time > 0) || (x==fx && y==fy && hard_or_not_hard[type]==TRUE)) {
		kill_player(n);
		return;
	}
	
	/*
	Test if the player is on a bonus:
	*/
	if (type >= bonus1 && type <=bonus7b) {
		type=type>>1;
		if (type == bonus1/2) { //Tete de mort
			player[n].sick = random(number_of_illness)+1;
			player[n].sick_time = SICK_TIME;
		}
		if (type == bonus2/2) {
			player[n].power+=player[n].power<8;
		}
		if (type == bonus3/2) {
			player[n].number_of_bomb_left+=player[n].number_of_bomb<8;
			player[n].number_of_bomb+=player[n].number_of_bomb<8;
		}
		if (type == bonus4/2) {
			player[n].can_put_line = TRUE;
			player[n].can_explode_all = FALSE;
			player[n].can_teletransport = FALSE;
		}
		if (type == bonus5/2) {
			player[n].time_ghost = 250;
			player[n].is_a_ghost = TRUE;
		}
		if (type == bonus6/2) {
			player[n].can_put_line = FALSE;
			player[n].can_explode_all = FALSE;
			player[n].can_teletransport = TRUE;
		}	
		if (type == bonus7/2) {
			player[n].can_put_line = FALSE;
			player[n].can_explode_all = TRUE;
			player[n].can_teletransport = FALSE;
		}
		delete_animated_tile(x,y);
		draw_status();
		return;
	}

	/*
	This tests if the player is on one of the teletransporter
	*/
	if (player[n].is_being_teletransported == FALSE) {
		for (i=0;i<16;i+=4) {
			if (x==transporterr[i] && y==transporterr[i+1]) {
				player[n].t_x = (transporterr[i+2]<<4);
				player[n].t_y = (transporterr[i+3]<<4)-5;
				player[n].t_frame =  0;
				player[n].is_being_teletransported =  TRUE;
				if (ai[n].on == TRUE) {
					ai[n].goal_x = player[n].t_x;
					ai[n].goal_y = player[n].t_y;
				}
			} 
		}
	}
	
	/*
	Test if player is stuck
	*/
	if (maps[m_static_tile][x][y] == soft_block && player[n].is_a_ghost == FALSE && player[n].is_being_teletransported == FALSE) {
		player[n].t_x = spawnx[n];
		player[n].t_y = spawny[n];
		player[n].t_frame =  0;
		player[n].is_being_teletransported =  TRUE;
		if (ai[n].on == TRUE) {
			ai[n].goal_x = player[n].t_x;
			ai[n].goal_y = player[n].t_y;
		}
	}
	
	/*
	This tests if the player is on the edge of the map
	*/
	if (player[n].x > (160-16+2) || player[n].x<16-2 || player[n].y>203+2 || player[n].y<11-2) {
	
		x=player[n].x;
		y=player[n].y;
		if (x>(160-16+2))
		x=16;
		if (x<16-2)
		x=160-16;
		if (y<11-2)
		y=203;
		if (y>203+2)
		y=11;

			player[n].x=x;		
			player[n].y=y;
			
		if (ai[n].on == TRUE) {
			ai[n].goal_x = player[n].x;
			ai[n].goal_y = player[n].y;
		}
	}	
}

/*********************************************************************************************************
 * We are talking about the "offset" of the zone that will be copied from the buffer to the the screen
 *********************************************************************************************************/
static inline void calculate_offset() {
	/*
	Calculates the vertical offset
	*/
	short K=((CALCULATOR>0)*14);//14=(128-100)/2
	screen_offset_y=0;
	if (player[playernum].y > 30+K)
	screen_offset_y = player[playernum].y-30-K;
	if (player[playernum].y >180-K)
	screen_offset_y = 150-(K<<1);
	screen_offset_y*=30;
}


/*********************************************************************************************************
 * This routine is called when try to drop a line of bomb; it puts bomb according to:
 *		-how many bombs you have
 *		-what direction you are facing
 *		-the obstacles on the path of the line (wall or player) 
 *********************************************************************************************************/
void put_line_of_bomb(short ix, short iy, short n) {
	short i=0,j;
	short x = (player[n].x+8)>>4;
	short y = (player[n].y+10)>>4;
	short p_o_x=(ix>0)*11,p_o_y=(iy>0)*15;
	short xx=0,yy=0;
	/*
	System to find wich player might be an obstacle when putting a 
	line of bomb, because the line stops when a player is in the way.
	*/
	for (i=0;i<4;i++) {
	if (i!=n) {
		yy=(player[i].y+10)>>4;
		xx=(player[i].x+8)>>4;
	}
		if (ix != 0) {
			if (yy==y) {
				p_o_y = y;
				if (ix<0 && xx < x && p_o_x < xx)
				p_o_x = xx;
				if (ix>0 && xx > x && p_o_x > xx)
				p_o_x = xx;
			}
		}
		else {
			if (xx==x) {
				p_o_x = x;
				if (iy<0 && yy < y && p_o_y < yy)
				p_o_y = yy;
				if (iy>0 && yy > y && p_o_y > yy)
				p_o_y = yy;
			}			
		}
	}
	i=0;
	while (maps[m_solid][x+i*ix][y+i*iy] == FALSE && player[n].number_of_bomb_left>0 && (p_o_x != x+ix*i || p_o_y != y+iy*i)) {
		player[n].number_of_bomb_left--;
		j=0;
		while (bombs[j].on == 1) {j++;};
		bombs[j].on = TRUE;
		bombs[j].time = player[n].time_till_explosion;
		bombs[j].x = x+i*ix;
		bombs[j].y = y+i*iy;
		bombs[j].size = player[n].power;
		bombs[j].player = n;
		maps[m_solid][x+i*ix][y+i*iy] = TRUE;
		maps[m_animated_tile][x+i*ix][y+i*iy] = bomb_large;
		maps[m_time][x+i*ix][y+i*iy] = 9;
		i++;
		change_danger_level(j);
	}
	draw_status();
}

/*********************************************************************************************************
 * Explodes all the bombs of player #n
 *********************************************************************************************************/
void explode_bombs(short n) {
	short i;
	for (i=0;i<MAX_NUM_OF_BOMB;i++) {
		if (n==bombs[i].player && bombs[i].on && bombs[i].time > 0)
		bombs[i].time = 1;
	}
}

/*********************************************************************************************************
 * Moves the human controled player
 *********************************************************************************************************/

void move_player(short n) {	
	short vx=0,vy=0;
	if(_keytest(RR_LEFT))
	vx = -MOVE_VECTOR;
	if(_keytest(RR_RIGHT))
	vx = MOVE_VECTOR;
	if(_keytest(RR_UP)	&& vx == 0)
	vy = -MOVE_VECTOR;
	if(_keytest(RR_DOWN) && vx == 0)
	vy = MOVE_VECTOR;
	if (player[n].sick == si_reverse) {
		vx=-vx;
		vy=-vy;
	}
	
	
	/*
	If the player has the "si_slow" sickness, all his movements are twice as slow.
	*/
	if (player[n].sick == si_slow) {
		vx=vx>>1;
		vy=vy>>1;
	}
	/*
	And vice versa...
	*/
	if (player[n].sick == si_ultraspeed) {
		vx=vx<<1;
		vy=vy<<1;
	}
	
	
	
	/*
	This makes the players "walk"
	*/
	if (vy != 0 || vx != 0) {
		player[n].interstep++;
	}
	else
	{
		player[n].interstep = 0;
  	player[n].step = 0;
	}
	if (player[n].interstep == NUM_OF_INTERSTEP) {
		player[n].interstep = 0;
		player[n].step++;
		if (player[n].step == NUM_OF_STEP)
		player[n].step = 0;
	}
	
	
	/*
	Set the direction of the player according to vx and vy.
	*/
	if (vx > 0) {
		player[n].dir = DIR_RIGHT;
	}
	if (vx < 0) {
		player[n].dir = DIR_LEFT;
	}
	if (vy > 0) {
  	player[n].dir = DIR_DOWN;
	}
	if (vy < 0) {
		player[n].dir = DIR_UP;
	}
	
	
	/*
	Collision detection; if a collision is detected, vx or vy is changed (but the direction of the player will not be affected).
	*/
	testmove(&vx,&vy,n);
	
	/*
	Update the player's x and y.
	*/
	player[n].x += vx;
	player[n].y += vy;
	
	
	if ((_keytest(put_bomb[calc_num].row,put_bomb[calc_num].col) || player[n].sick == si_dairrhea) && player[n].sick != si_constipation) {
		player[n].has_put_a_bomb = TRUE;
		drop_a_bomb(playernum);
	}


	
	/*
	This part handles the bonus key
	*/
	
	
	if (_keytest(put_line[calc_num].row,put_line[calc_num].col) && (player[n].can_put_line || player[n].can_teletransport || player[n].can_explode_all)) {
		player[n].has_hit_the_bonus_key = TRUE;
		//			  3
    //
    //	   2		 0
    //
    //				1
    if (player[n].can_teletransport) {
    	short x,y;
    	do {
    		x=random(LEVEL_WIDTH-2)+1;
    		y=random(LEVEL_HEIGHT-2)+1;
    	} while (maps[m_solid][x][y] == TRUE);
    	player[n].t_x = x<<4;
     	player[n].t_y = (y<<4)-5;
     	player[n].is_being_teletransported = TRUE;
     	player[n].t_frame = 0;	
    }
    else {
	    if (player[n].can_put_line) {
		    if (player[n].dir == DIR_RIGHT)
		   	put_line_of_bomb(1,0,n);
		    if (player[n].dir == DIR_LEFT)
		   	put_line_of_bomb(-1,0,n);    	
		    if (player[n].dir == DIR_DOWN)
		   	put_line_of_bomb(0,1,n);
		    if (player[n].dir == DIR_UP)
		   	put_line_of_bomb(0,-1,n);
			}
		  else
			{
		 		explode_bombs(n);
		  }
		}
	}
}

/*********************************************************************************************************
 *		returns 0 if you can walk into the tile
 *********************************************************************************************************/

short get_tile(short x,short y,short n) {
	if (player[n].is_a_ghost==FALSE)
	return(maps[m_solid][x>>4][y>>4]);
	return(maps[m_solid][x>>4][y>>4]&(!(maps[m_static_tile][x>>4][y>>4]==soft_block)));
}

/*********************************************************************************************************
 *				colision detection & smooth cornering system. (f*****g painful to do)
 *********************************************************************************************************/
void testmove(short *vx, short *vy, short n) {
	short x=player[n].x+*vx,y=player[n].y+6+*vy;
	
	short g1	=  get_tile(x+14,y,n);
	short g4	=	 get_tile(x+1,y,n);
	short g7	=	 get_tile(x+1,y+13,n);
	short g10 =  get_tile(x+14,y+13,n);
	short gX = get_tile(x+7,y+6,n);

	if (player[n].dir == DIR_DOWN) {
		short g8	=	 get_tile(x+4,y+13,n);
		short g9	=	 get_tile(x+10,y+13,n);
		if (g8 != 0 && g9 != 0  && !(gX != 0 && ((y+6)>>4) == ((y+13)>>4))) {
 			*vx = 0;
    	*vy = 0;
      //return;
		}
		if (g7 != 0 && g9 == 0) {
			*vx = MOVE_VECTOR;
			*vy = 0;
			//return;
 		}
    if (g10 != 0 && g8 == 0) {
			*vx = -MOVE_VECTOR;
			*vy = 0;
			//return;
		}
		return;
	}
	if (player[n].dir == DIR_UP) {
		short g2	=	 get_tile(x+10,y,n);
		short g3	=	 get_tile(x+4,y,n);
		if (g3 != 0 && g2 != 0 && !(gX != 0 && ((y+6)>>4) == ((y)>>4))) {
			*vx = 0;
			*vy = 0;
			//return;
		}
		if (g4 != 0 && g2 == 0) {
			*vx = MOVE_VECTOR;
			*vy = 0;
			//return;
		}
		if (g1 != 0 && g3 == 0) {
			*vx = -MOVE_VECTOR;
			*vy = 0;
			//return;
		}          
	}
	if (player[n].dir == DIR_RIGHT) {
		short g11 =  get_tile(x+14,y+11,n);
		short g12 =  get_tile(x+14,y+3,n);
		if (g12 != 0 && g11 != 0 && !(gX != 0 && ((x+7)>>4)==((x+14)>>4) )) {
			*vx = 0;//-2;
			*vy = 0;
			//return;
		}
		if (g10 != 0 && g12 == 0) {
			*vx = 0;
			*vy = -MOVE_VECTOR;
			//return;
		}
		if (g1 != 0 && g11 == 0) {
			*vx = 0;
			*vy = MOVE_VECTOR;
			//return;
			}
		};
	if (player[n].dir == DIR_LEFT ) {
		short g5	=	 get_tile(x+1,y+3,n);
		short g6	=  get_tile(x+1,y+11,n);        
		if (g5 != 0 && g6 != 0 && !(gX != 0 && ((x+7)>>4)==((x+1)>>4) ) ) {
			*vx = 0;//2;
			*vy = 0;
			//return;
		}
		if (g7 != 0 && g5 == 0) {
			*vx = 0;
			*vy = -MOVE_VECTOR;
			//return;
		}
		if (g4 != 0 && g6 == 0) {
			*vx = 0;
			*vy = MOVE_VECTOR;
			//return;
		}
  }
}


/*********************************************************************************************************
*		Copy the background to the buffer
*********************************************************************************************************/
static inline void copy_buffer_to_virtual() {
  short large_s = (CALCULATOR>0)*28*30;
  memcpy(virtual[DARK1]+screen_offset_y+screen_offset_x,virtual[DARK2]+screen_offset_y+screen_offset_x,90*30+large_s);
  memcpy(virtual[LIGHT1]+screen_offset_y+screen_offset_x,virtual[LIGHT2]+screen_offset_y+screen_offset_x,90*30+large_s);
}


/*********************************************************************************************************
*		Copy the buffer to the screen
*********************************************************************************************************/
static inline void copy_virtual_to_screen(short msg) {
  short large_s = (CALCULATOR>0)*28*30;
	//Draws the masking part of the igloo
	if (level_num == l_igloo)
	draw_igloos();
	short pause=FALSE;
	
	if (msg!=0) {
   	char*s[]={(char*)&"Hurry!",(char*)&"Time's up"};
   	draw_sexy_string(s[msg-1]);
	}

	
	if (link_on==FALSE && _keytest(RR_F5)) {
   	screen_offset_y-=30*30;
   	draw_sexy_string((char*)&"*Paused*");
    screen_offset_y+=30*30;	 	
  	draw_sexy_string((char*)&"Press [F5]");
    pause = TRUE;
  }
  memcpy(GrayGetPlane (DARK_PLANE),virtual[DARK1]+screen_offset_y+screen_offset_x,90*30+large_s);
  memcpy(GrayGetPlane (LIGHT_PLANE),virtual[LIGHT1]+screen_offset_y+screen_offset_x,90*30+large_s);
   if (pause == TRUE) {
		while (_keytest(RR_F5)) {};
		while (!_keytest(RR_F5)) {};
		while (_keytest(RR_F5)) {};
  }
}



/*********************************************************************************************************
*		Draws a player in the buffer
*********************************************************************************************************/
void draw_players() {

	/*
	Why such a "big" routine ?
	The players must be drawn in an order depending on their y-coordinate. 
	This is to maintain the illusion of depth. So the highest player on the screen 
	is drawn the first, and the lowest is drawn last.
	To achieve this, I use an array containing the sorted indexes of the players.
	*/
	
	short l[4];//index of the sorted players
	short i;
	
	//Round 1:
	if (player[0].y > player[1].y) {
		l[0]=1;
		l[2]=0;
	}
	else
	{
		l[0]=0;
		l[2]=1;
	}
	

	if (player[2].y > player[3].y) {
		l[1]=3;
		l[3]=2;
	}
	else
	{
		l[1]=2;
		l[3]=3;
	}
	
	//Round 2:
	//Compares the provisional two lowest values and sorts them:
	if (player[l[0]].y > player[l[1]].y) {
		EXT_XCHG(l[0],l[1]);
	}
	//Compares the provisional two highest values and sorts them:	
	if (player[l[2]].y > player[l[3]].y) {
		EXT_XCHG(l[2],l[3]);
	}	
	
	//Compares the 2 middle values and sorts them:
	if (player[l[1]].y > player[l[2]].y) {
		EXT_XCHG(l[1],l[2]);
	}
	
	//The sorting is now over!
	
	for (i=0;i<4;i++) {
		if (player[l[i]].is_drawn == TRUE) {
			if (player[l[i]].is_dying == FALSE) {
				draw_player(l[i]);
			}
			else
			{
				draw_dying_player(l[i]);
			}
		}
	}	
}

/*********************************************************************************************************
 *		When in multiplayer mode, if one player is dead and the other one is still fighting agains bot, the
 * 		dead player can "spectate" the game.
 *********************************************************************************************************/
static inline void move_in_ghost_mode() {
	if (_keytest(RR_UP))
	player[playernum].y-=3;
	if (_keytest(RR_DOWN))
	player[playernum].y+=3;
	if (player[playernum].y<25)
	player[playernum].y=25;
	if (player[playernum].y>200)
	player[playernum].y=200;	
}




/*********************************************************************************************************
 *			This draws the message at the beginning of the game
 *********************************************************************************************************/
static unsigned char arrowX[7*2]={
	0b00010000,
	0b00110000,
	0b01111111,
	0b11111111,
	0b01111111,
	0b00110000,
	0b00010000,
	0b00001000,
	0b00001100,
	0b11111110,
	0b11111111,
	0b11111110,
	0b00001100,
	0b00001000};
	
static inline void draw_messages(short round) {
	FontSetSys (F_8x10);
	short i;
	char *str;
	char message[10];
	for (i=0;i<70;i++) {
		copy_buffer_to_virtual();
		draw_players();
		if (i<50) {
			
			
			GraySprite8_OR_R(
			player[playernum].x+5+15*(((player[playernum].x<=70)<<1)-1)+random(3),
			player[playernum].y+7,
			7,
			&arrowX[((player[playernum].x>70)*7)],
			&arrowX[((player[playernum].x>70)*7)],
			virtual[DARK1],			
			virtual[LIGHT1]);
			
			
		}
		str = NULL;
		
		if (i>15 && i < 25) {
			sprintf(message,"Round #%i",round);
			str = &message[0];
		}		

		if (i>30 && i < 45) {
			str = (char*)&"Ready";
		}
		if (i>55) {
			str = (char*)&"GO!";
		}
		if (str!=NULL) {
			draw_sexy_string(str);
		}
		else
		{
			pokeIO(0x600005,0b11101);
		}
		animate_background();
		copy_virtual_to_screen(0);
	}
	FontSetSys (F_4x6);
}


/*********************************************************************************************************
*		This data is for the falling blocks
*********************************************************************************************************/

static char f_v_x[] 		= {1	,0	,-1	,0	};
static char f_v_y[] 		= {0	,1	,0	,-1	};
static char f_lim[]			= {9	,13	,1	,2	};

static short f_shadow[] = {
	0b0000000000000000,
	0b0000000000000000,
	0b0001111111111000,	
	0b0011111111111100,		
	0b0111111111111110,
	0b0111111111111110,	
	0b0111111111111110,	
	0b0111111111111110,	
	0b0111111111111110,
	0b0111111111111110,	
	0b0111111111111110,	
	0b0111111111111110,	
	0b0011111111111100,	
	0b0001111111111000,	
	0b0000000000000000,
	0b0000000000000000	
};





/*********************************************************************************************************
*		The play function !
*********************************************************************************************************/


static inline void play() {


	short i;
	short quit = FALSE;
	short result=0;
	char* address;	
	short round=0;
	short k=0;
	for (i=4;i--;)
	player[i].num_of_vic = 0;	
	
	playernum=0;
		
	//Get the preferences.
	PREF_STRUCT pref;
	
	read_data(&pref);
	
	
	
	/*
	Synchronize the 2 calcs if link mode is on.
	*/
	link_on = pref.prefs[link_mode];
	if (link_on == TRUE) {
		if (call_other_calc()==FALSE)
		return;
		read_data(&pref);
	}
	srand(pref.random_seed);
	do {		
		
		
		short limited_time = pref.prefs[falling_block];
		short time = 400;
		
		short f_block_x=-1,f_block_y=0,f_block_real_y=0;
		short f_block_i=0,f_block_l=0;
		
		
		round++;
		level = pref.prefs[map_num];
		if (pref.prefs[rand_map] == TRUE)
		level = random(NUMBER_OF_LEVEL-1);
		number_of_ennemies = pref.prefs[ennemi_num];
		number_bonus = 3+pref.prefs[bonus_num];
		otherplayernum = !playernum;
		screen_offset_x = -4+5*TI89;
		
		draw_background_in_buffer();
		
		/**************************
		Initialize all the players:
		***************************/
		for (i=4;i--;) {
			player[i].is_drawn = FALSE;//This var tells me if the player must be drawn.
		  player[i].is_playing = FALSE;//This var tells me if the player must be moved.
		  player[i].is_dying = FALSE;//This var tells me if the player is dying (ie is falling to the ground)
			player[i].is_being_teletransported = FALSE;
			
			/*
			Randomize the start up positions if the option was selected. This has nothing to do with 'i' (it used to be in it's own loop, but putting this in an already existing loop is a size optimisation).
			*/
			if (pref.prefs[rand_pos] == TRUE) {
				short a=random(4);
				short b=random(4);
				EXT_XCHG(spawnx[a],spawnx[b]);
				EXT_XCHG(spawny[a],spawny[b]);
			}
		}
		

	
		for (i = 0; i <= number_of_ennemies; i++) {
	   	
	   	
	   	player[i].x = spawnx[i];
	  	player[i].y = spawny[i];
	  	
	 
	  	player[i].can_put_line = FALSE;
	  	player[i].can_teletransport = FALSE;
	  	player[i].can_explode_all = FALSE;
	   	player[i].sick = si_not_sick;
	  	player[i].is_a_ghost = FALSE;   	
	  	player[i].time_till_explosion = 100;
	   	player[i].power = 1;  	
	   	player[i].number_of_bomb=1;    
	   	if (level_num == l_power) {
		   	player[i].power = 7;  	
		   	player[i].number_of_bomb=5;
		   	player[i].can_put_line = TRUE ;
	   	}
	   	if (level_num == l_EJC) {
		   	player[i].power = 0;  	
		   	player[i].number_of_bomb=0;
	   	}
	   	player[i].number_of_bomb_left=player[i].number_of_bomb;

	  	player[i].quit = FALSE;
	   	player[i].has_put_a_bomb = FALSE;
	   	player[i].has_hit_the_bonus_key = FALSE;
	
	   	player[i].dir = DIR_DOWN;
	   	player[i].step = 0;
			player[i].is_drawn = TRUE;//This var tells me if the player must be drawn.
		  player[i].is_playing = TRUE;//This var tells me if the player must be moved.



	 	  ai[i].on = FALSE;
	   	if (i>1 || (i==1 && link_on == FALSE)) {
		   	ai[i].goal_x = spawnx[i];	
		    ai[i].goal_y = spawny[i];
		    ai[i].on = TRUE;
		  }
	  }
	
	 	/*
		Initialize the bombs:
	  */
	  memset(bombs,0,sizeof(BOMB)*MAX_NUM_OF_BOMB);
	  	
		/*
		Accelerate the timer.
		*/
		pokeIO(0x600017,0xFA);
		memset(GrayGetPlane(1)+90*30,0,30*9);
		memset(GrayGetPlane(0)+90*30,0,30*9);
		draw_status();
		FontSetSys(F_4x6);
		calculate_offset();
		draw_messages(round);
		short number_of_players_left=4; //The value doesn't matter as long as it's more than 1
		short x,y;
		

		
		/*###################################################
		#					THE BIG FAT IMPORTANT LOOP
		###################################################*/
		while (!fast_quit && !quit && (number_of_players_left > 1) &&	(player[playernum].is_drawn == TRUE || (link_on==TRUE && player[otherplayernum].is_drawn == TRUE))) {
			
			
			/*
			DEBUG
			*/
			if (DEBUG)
			GrayDrawStr(0,0,"1a",A_REPLACE);

			if (level == l_SPACE) {
				for (i=LEVEL_HEIGHT;i--;) {
					maps[m_solid][LEVEL_WIDTH-1][i] = maps[m_solid][1][i];
					maps[m_solid][0][i] = maps[m_solid][LEVEL_WIDTH-2][i];
					maps[M_DANGER_AI][LEVEL_WIDTH-1][i] = maps[m_solid][1][i];
					maps[M_DANGER_AI][0][i] = maps[m_solid][LEVEL_WIDTH-2][i];
				}
				for (i=LEVEL_WIDTH;i--;) {
					maps[m_solid][i][LEVEL_HEIGHT-1] = maps[m_solid][i][1];
					maps[m_solid][i][1] = maps[m_solid][i][LEVEL_HEIGHT-2];
					maps[M_DANGER_AI][i][LEVEL_HEIGHT-1] = maps[m_solid][i][1];
					maps[M_DANGER_AI][i][1] = maps[m_solid][i][LEVEL_HEIGHT-2];						
				}
			}


			time-=limited_time&(time>-90);
			
			
			/*
			DEBUG
			*/
			if (DEBUG)
			GrayDrawStr(0,0,"1b",A_REPLACE);
			
			/*
			Calculates the number of player left and initialize some variable for each player at every frame:
			*/
			number_of_players_left=0;
			for (i=0;i<=number_of_ennemies;i++) {
				player[i].has_put_a_bomb = FALSE;	
	   		player[i].has_hit_the_bonus_key = FALSE;
	   		player[i].quit = FALSE;
	   		number_of_players_left += (player[i].is_drawn);
			}
			
			if (_keytest(RR_ESC)) {
					player[playernum].quit = TRUE;
					fast_quit = TRUE;
			}
			
			if (_keytest(RR_CLEAR))
			player[playernum].quit = TRUE;

			/*
			DEBUG
			*/
			if (DEBUG)
			GrayDrawStr(0,0,"2a",A_REPLACE);
			
			
			/*
			Move the AI if she's alive:
			*/
			for (i=1;i<=number_of_ennemies;i++) {
				if (ai[i].on == TRUE && player[i].is_playing == TRUE) {
					if (player[i].is_being_teletransported == TRUE) {
						player[i].t_frame++;
						if (player[i].t_frame == PERSO_SPRITE_HEIGHT) {
							player[i].x = player[i].t_x;
							player[i].y = player[i].t_y;			
							player[i].is_being_teletransported = FALSE;
						}
					}
					else
					{
						move_ai(i);
					}
				}
			}


			/*
			DEBUG
			*/
			if (DEBUG)
			GrayDrawStr(0,0,"3a",A_REPLACE);
			
			
			/*
			The main player can only move if he is playing and if he isn't transporting his self.
			*/
			if (player[playernum].is_playing == TRUE) {
				if (player[playernum].is_being_teletransported == TRUE) {
					player[playernum].t_frame++;
					if (player[playernum].t_frame == PERSO_SPRITE_HEIGHT) {
						player[playernum].x = player[playernum].t_x;
						player[playernum].y = player[playernum].t_y;			
						player[playernum].is_being_teletransported = FALSE;
					}
				}
				else
				{
					move_player(playernum);
				}
			}


			/*
			DEBUG
			*/
			if (DEBUG)
			GrayDrawStr(0,0,"4a",A_REPLACE);

			
			/*
			Otherwise he can only spectate (the so-called 'ghost mode')
			*/			
			if (player[playernum].is_drawn == FALSE)
			move_in_ghost_mode();
			calculate_offset();
			
			
			/*
			!
			*/
			if (link_on) {
				if (player[otherplayernum].is_being_teletransported == TRUE) {
					player[otherplayernum].t_frame++;
					if (player[otherplayernum].t_frame == PERSO_SPRITE_HEIGHT)
					player[otherplayernum].is_being_teletransported = FALSE;
				}
				
				send_and_receive_data();
				quit = player[playernum].quit|player[otherplayernum].quit;
				if (player[otherplayernum].is_drawn == TRUE) {
					if (player[otherplayernum].has_put_a_bomb == TRUE)
					drop_a_bomb(otherplayernum);
					if (player[otherplayernum].has_hit_the_bonus_key == TRUE) {
						if (player[otherplayernum].can_put_line == TRUE) {
							if (player[otherplayernum].dir == 0)
				    	put_line_of_bomb(1,0,otherplayernum);
				    	if (player[otherplayernum].dir == 2)
				    	put_line_of_bomb(-1,0,otherplayernum);    	
				    	if (player[otherplayernum].dir == 1)
				    	put_line_of_bomb(0,1,otherplayernum);
				    	if (player[otherplayernum].dir == 3)
				    	put_line_of_bomb(0,-1,otherplayernum);
				    }
				    else
				    {
				    	if (player[otherplayernum].can_teletransport == TRUE) {
					    	do {
					    		x=random(LEVEL_WIDTH-2)+1;
					    		y=random(LEVEL_HEIGHT-2)+1;
					    	} while (maps[m_solid][x][y] == TRUE);
								player[otherplayernum].is_being_teletransported = TRUE;
					    	player[otherplayernum].t_frame = 0;
					    }
					    else
					    {
					    	explode_bombs(otherplayernum);
					    }
				    }
			    }
	    	}
			}
			


			/*
			DEBUG
			*/
			if (DEBUG)
			GrayDrawStr(0,0,"5a",A_REPLACE);
			
			
			
			
			

			quit = player[0].quit|player[1].quit;
	
			/*
			Animate the bombs, make them explode and calculate the dangerous zone for the AI:
			*/
			update_bombs();
			
			
			
			/*
			DEBUG
			*/
			if (DEBUG)
			GrayDrawStr(0,0,"5b",A_REPLACE);	
			
			
			/*
			Animate background (the teletransporters, the exploding blocks, the bonus, the explosions...)
			*/
			animate_background();
						
			/*
			DEBUG
			*/
			if (DEBUG)
			GrayDrawStr(0,0,"5c",A_REPLACE);
			
			
			for (i=0;i<4;i++) {
				if (player[i].is_playing == TRUE) {
					on_what_is_the_player(i,f_block_x,f_block_y);
				}
			}		
	
			/*
			DEBUG
			*/
			if (DEBUG)
			GrayDrawStr(0,0,"5d",A_REPLACE);	
	
	
			/*
			there's a Frame skip when "hurry up" is displayed (because otherwise the game would really slow down)
			*/
			if (time > 0 || time <= -15 || (time & 1)) {
			/*
			Copy the background into the virtual screen.
			*/
			copy_buffer_to_virtual();
			
			
			/*
			DEBUG
			*/
			if (DEBUG)
			GrayDrawStr(0,0,"5e",A_REPLACE);
			
			
			/*
			Draw the players on the virtual screen.
			*/	
			draw_players();


			/*
			DEBUG
			*/
			if (DEBUG)
			GrayDrawStr(0,0,"6a",A_REPLACE);	

			
			/*
			Draw the falling block if enabled
			*/
			if (time < -88) {
				if (f_block_x == -1) {
					f_block_x=hard_or_not_hard[maps[m_static_tile][0][0]];
					f_block_y+=f_block_x;
					f_block_l+=f_block_x;
					f_block_real_y = f_block_y-80;
				}

				if (f_block_y<<4 == f_block_real_y) {
					if (hard_or_not_hard[maps[m_static_tile][f_block_x][f_block_y]] == FALSE || maps[m_static_tile][f_block_x][f_block_y]==soft_block) {
						
						/*
						Give back to the player the bomb that might be under the falling block
						*/
						if (maps[m_animated_tile][f_block_x][ f_block_y] == bomb_large || maps[m_animated_tile][ f_block_x][ f_block_y] == bomb_small) {
							k=0;
							for (;k<MAX_NUM_OF_BOMB;k++) {
								if (bombs[k].x == f_block_x && bombs[k].y == f_block_y) {
									bombs[k].on = FALSE;
									player[bombs[k].player].number_of_bomb_left++;
									k=MAX_NUM_OF_BOMB;
								}
							}
						}
						
						
						/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
						TO DO:

						%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
						
						
						
						maps[m_static_tile][f_block_x][f_block_y] = hard_block;
						maps[m_solid][f_block_x][f_block_y] = TRUE;
						delete_animated_tile(f_block_x,f_block_y);

					}
					f_block_x+=f_v_x[f_block_i];
					f_block_y+=f_v_y[f_block_i];
					f_block_real_y=(f_block_y<<4)-80;
					if (			(f_block_x > f_lim[f_block_i]-f_block_l && f_v_x[f_block_i]>0) || 
										(f_block_x < f_lim[f_block_i]+f_block_l && f_v_x[f_block_i]<0) || 
										(f_block_y > f_lim[f_block_i]-f_block_l && f_v_y[f_block_i]>0) || 
										(f_block_y < f_lim[f_block_i]+f_block_l && f_v_y[f_block_i]<0)) {
						f_block_i++;
						if (f_block_i == 4) {
							f_block_i = 0;
							f_block_l++;
							if (f_block_l>3) {
								for (k=4;k--;) {	//Kill them all!
									if (player[k].is_playing)
									kill_player(k);
								}
							}
						}
					}
				}
				f_block_real_y+=5;
				
				if (hard_or_not_hard[maps[m_static_tile][f_block_x][f_block_y]] == FALSE || maps[m_static_tile][f_block_x][f_block_y]==soft_block) {
					GrayTile16x16_OR_R(f_block_x,converty(f_block_y),f_shadow,f_shadow,virtual[LIGHT1],virtual[DARK1]);
					draw_the_falling_block(f_block_x,f_block_real_y);
				}
				/*
				So the AI knows the falling block is dangerous:
				*/
				short gg,gx=f_block_x,gy=f_block_y,gl=f_block_l,gi=f_block_i;
				for (gg=5;gg--;) {
					maps[M_DANGER_AI][gx][gy] = TRUE;
					gx+=f_v_x[gi];
					gy+=f_v_y[gi];
						
						if ((gx > f_lim[gi]-gl && f_v_x[gi]>0) || 
								(gx < f_lim[gi]+gl && f_v_x[gi]<0) || 
								(gy > f_lim[gi]-gl && f_v_y[gi]>0) || 
								(gy < f_lim[gi]+gl && f_v_y[gi]<0)) {
						gi++;
						if (gi == 4) {
							gi = 0;
							gl++;
						}
					}
				}			

					
			}	

			/*
			DEBUG
			*/
			if (DEBUG)
			GrayDrawStr(0,0,"7 ",A_REPLACE);



			/*
			This is to visualize the dangerous zone (ie the zone the AI is supposed to avoid)
			*/
			/*
			short kx,ky;
			for (kx=LEVEL_WIDTH;kx--;) {
				for (ky=LEVEL_HEIGHT;ky--;) {
					if (maps[M_DANGER_AI][kx][ky])
					GrayTile16x16_OR_R(kx,converty(ky),S_tile,S_tile,virtual[LIGHT1],virtual[DARK1]);
				}
			}
			*/
			

			/*
			Copy the virtual screen onto the screen.
			*/
			copy_virtual_to_screen((time < 1 && time > -20)+ ((time < -20 && f_block_l>3)<<1));
			

			

			}
			while(end_of_timer) {};
			Mseconds=0;
		}
		
		
		/*
		This draws the game results
		*/
		if (!quit && !fast_quit) { 
		
			number_of_players_left = 0;
			for (i=4;i--;)
			number_of_players_left +=player[i].is_playing ;

			if (number_of_players_left<1 && player[playernum].is_playing == FALSE) {
				end_of_game(g_draw);
			}
			else {
				GrayClearScreen();
				GrayDrawRect(0,0,LCD_WIDTH,LCD_HEIGHT-1,COLOR_DARKGRAY,RECT_FILLED);
				
				short j;
				for (i=number_of_ennemies+1;i--;) {
					GrayDrawRect(19+6,(i*24)+2,131+6,(i*24)+26,COLOR_BLACK,RECT_FILLED);
					GrayDrawRect(20+6,(i*24)+3,130+6,(i*24)+25,COLOR_WHITE,RECT_FILLED);
					address=(generated_sprites[i]+1*88*4);
					GraySprite16_OR(
					24+6,
					i*24+3,
					PERSO_SPRITE_HEIGHT,
					(short*)address,
					(short*)address+22,
					GrayGetPlane(DARK_PLANE),
					GrayGetPlane(LIGHT_PLANE));
					for (j=0;j<player[i].num_of_vic;j++)
					GraySpriteX8_OR(44+j*20+6,i*24+6,16,cup_layer1,cup_layer2,3,GrayGetPlane(1),GrayGetPlane(0));
				}
				char strr[20];
				sprintf(strr,"TOTAL %i",pref.prefs[round_num]);
				vertical_string(strr, 4 , 10);		
				sprintf(strr,"ROUND %i",round);		
				vertical_string(strr, 148 , 10);
				memcpy(virtual[0],GrayGetPlane(0),LCD_SIZE);
				memcpy(virtual[1],GrayGetPlane(1),LCD_SIZE);		
				for (i=number_of_ennemies+1;i--;) {
					if (player[i].is_playing == TRUE)
					player[i].num_of_vic++;
					if (player[i].num_of_vic>result)
					result = player[i].num_of_vic;

					for (j=0;j<player[i].num_of_vic;j++)
					GraySpriteX8_OR(44+j*20+6,i*24+6,16,cup_layer1,cup_layer2,3,virtual[1],virtual[0]);
				}
			}
			if (link_on == FALSE) {
				crossing_transition();
				if (fast_quit == FALSE) {
					while (!_keytest(RR_ENTER)) {};
					while (_keytest(RR_ENTER)) {};
				}
			}
		}
		
	} while  (result < pref.prefs[round_num] && fast_quit == FALSE && !quit);
	/*
	The folowing code is executed when the game is finished
	*/
	if (fast_quit==FALSE) {
	
		if (player[playernum].num_of_vic == pref.prefs[round_num])
		end_of_game(g_win);
		else
		end_of_game(g_loss);
	}
	if (link_on==TRUE)
	OSLinkClose();
	pokeIO(0x600017,(HW_VERSION==1?0xB2:0xCC));
}


/*********************************************************************************************************
*		Main Function
*********************************************************************************************************/
void _main(void) {

	/*
	 malloc(42456)
	*/
  #define A		LCD_SIZE  +  4*(1408+432)  +  MAX_NUM_OF_BOMB*sizeof(BOMB)  +  BUFFER_SIZE*4  +  15*11*6*sizeof(short)
 
	fast_quit=FALSE;
	calc_num = CALCULATOR-V200;
	randomize();
	buffer = malloc(A);
	
	if (!buffer) {
    ST_helpMsg("mem allocation failed");
	  exit(0);
  }
  

 	memset(buffer,0,A); 
  LCD_save (buffer);
	generated_sprites[0] 		= (char*)(buffer+LCD_SIZE);
	generated_sprites[1] 		= generated_sprites[0]+1408+432;
	generated_sprites[2] 		= generated_sprites[1]+1408+432;	
	generated_sprites[3] 		= generated_sprites[2]+1408+432;	
	bombs 									= (BOMB*)(char*)(buffer+LCD_SIZE+((1408+432)*4));
	virtual[LIGHT1]					= ((char*)bombs)+(MAX_NUM_OF_BOMB*sizeof(BOMB));
	virtual[DARK1] 					= virtual[LIGHT1] + BUFFER_SIZE;
	virtual[LIGHT2] 				= virtual[DARK1] + BUFFER_SIZE;
	virtual[DARK2] 					= virtual[LIGHT2] + BUFFER_SIZE;
	maps 			 							= virtual[DARK2] + BUFFER_SIZE;


	//Mem allocation debug:
	/*
	float n = (char*)maps - (char*)buffer;
	printf("  %f  ",n);
	ngetchx();
	*/
	
  generate_the_sprites();
	short i=1;
	INT_HANDLER save_int_1;
	save_int_1 = GetIntVec (AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
	INT_HANDLER save_int_5;
	save_int_5 = GetIntVec (AUTO_INT_5);
	SetIntVec (AUTO_INT_5, CLOCK_TIMER);
	if (GrayOn()) {
		memcpy(GrayGetPlane(0),LCD_MEM,LCD_SIZE);
		memcpy(GrayGetPlane(1),LCD_MEM,LCD_SIZE);		
		while (!fast_quit && i!=0) {
			i=menu();
			if (i==1)
			play();
		}
		
		memcpy(virtual[0],buffer,LCD_SIZE);
		memcpy(virtual[1],buffer,LCD_SIZE);
		crossing_transition();
		GrayOff();
		
		memcpy(LCD_MEM,buffer,LCD_SIZE);	
		ST_helpMsg("BomberDude v0.96 by JfG");

	}
	else
	{
    ST_helpMsg("Failed to activate grayscale");		
	}

		SetIntVec (AUTO_INT_1, save_int_1);
		SetIntVec (AUTO_INT_5 , save_int_5);

	free(buffer);
  
}



